// vMac 0.1 Source
// By Philip Cummins (PC)
// Copyright PC 1997

// PC - Mac Screen Headers

UBYTE       VRAM_Main_GetB        (CPTR addr);
UWORD       VRAM_Main_GetW        (CPTR addr);
ULONG       VRAM_Main_GetL        (CPTR addr);
void        VRAM_Main_PutB        (CPTR addr, UBYTE in);
void        VRAM_Main_PutW        (CPTR addr, UWORD in);
void        VRAM_Main_PutL        (CPTR addr, ULONG in);
UBYTE       VRAM_Alt_GetB         (CPTR addr);
UWORD       VRAM_Alt_GetW         (CPTR addr);
ULONG       VRAM_Alt_GetL         (CPTR addr);
void        VRAM_Alt_PutB         (CPTR addr, UBYTE in);
void        VRAM_Alt_PutW         (CPTR addr, UWORD in);
void        VRAM_Alt_PutL         (CPTR addr, ULONG in);

#define RegScreen         0xa0000

#define kVRAM_Base        0x5a0000
#define kVRAM_Top         0x600000
#define kVRAM_Size        kVRAM_Top - kVRAM_Base
/*
#define kMain_Offset      0x000000
#define kAlternate_Offset 0x300000

#define kMain_Buffer      (kVRAM_Base + kMain_Offset)
#define kAlternate_Buffer (kVRAM_Base + kAlternate_Offset)
*/
#define kOld_Main_Offset      0x5900
#define kOld_Alternate_Offset 0xD900
#define kOld_Main_Buffer      (kRAM_Size - kOld_Main_Offset)
#define kOld_Alternate_Buffer (kRAM_Size - kOld_Alternate_Offset)

#define scrnBase     kVRAM_Base

// 512x342
#define Bottom1      342
#define Right1       512
#define rowBytes1    Right2/8
#define screenBytes1 Bottom1*rowBytes2

// 640x480
#define Bottom2      480
#define Right2       640
#define rowBytes2    Right2/8
#define screenBytes2 Bottom1*rowBytes2

// /*
#define kMain_Offset      0x5900
#define kAlternate_Offset 0xD900
#define kMain_Buffer      (kRAM_Size - kMain_Offset)
#define kAlternate_Buffer (kRAM_Size - kAlternate_Offset)
// */

void Screen_Refresh(void);

extern int  Screen_Init  (void);

void Screen_Reset (void);
void Screen_Draw  (void);
void Screen_Recreate (void);
void Screen_Copy (void);
void Screen_Dump (void);
void Screen_Print (void);
void Screen_PrintSetup (void);
void Screen_PrintInit (void);
void Screen_DrawButtons (void);

// VIA Interface Headers

UBYTE VIA_GORA6 (void); // Main/Alternate Screen Buffer
void  VIA_PORA6 (UBYTE Data);

UBYTE VIA_GORB6 (void); // Video Beam in Display
void  VIA_PORB6 (UBYTE Data);
