/* Support for Gemulator ROM Board */

#include "sysconfig.h"
#include "sysdeps.h"
#include "config.h"
#include "options.h"
#include "custom.h"
#include "memory.h"

#include "Win32port.h"
#include "Prefs.h"

#include <dos.h>

/*
  Much of this code was written by Darek Michocka,
  and adapted to work in vMac.
*/

#define cbSocket (128*1024)
#define countSocket (8)

unsigned char bigbuf[cbSocket*countSocket*2];

int Gemulator_LoadROM(UBYTE * NewROM, UWORD Base, UBYTE Socket, UBYTE Length)
{
    int i;
    int rgsize[countSocket];

    SetStatus("Reading ROM board...");

    _outp(Base,0);

    //UI has socket 1 as the first, but we use 0 as the first
    --Socket;

    for (i = 0; i < (Socket+Length)*cbSocket; i++)
        bigbuf[i] = _inp(Base);

    for (i = 0; i < countSocket; i++)
    {
        unsigned char *pb = &bigbuf[i * cbSocket];
        int size = cbSocket/1024;

        while ((size > 32) && !memcmp(pb, pb+(size*512), size*512))
            size /= 2;

        rgsize[i] = size;
    }

    // scramble the bytes from socket order to byte order

    memmove(bigbuf + countSocket * cbSocket, bigbuf + Socket * cbSocket,
        Length * cbSocket);

    for (i = 0; i < countSocket * cbSocket; i++)
        bigbuf[i] = bigbuf[(countSocket + (i%Length)) * cbSocket + (i/Length)];

    memcpy(NewROM, bigbuf, 1024 * rgsize[Socket] * Length);

    SetStatus("");

    return(1024 * rgsize[Socket] * Length); //Return size
}