// vMac 0.1 Source
// By Philip Cummins (PC)
// Copyright PC 1997

// PC - Mac Screen Functions

#include "../includes/sysconfig.h"
#include "../includes/sysdeps.h"
#include "../config.h"
#include "../hardware/Screen.h"
#include "../hardware/RAM.h"
#include "../includes/prefs.h"
#include "Win32Port.h"

UBYTE vPage2 = 1;

UWORD private_VRAM_Main [screenBytes2];
UWORD *VRAM_Main = private_VRAM_Main;

UBYTE Draw_Count = 0;// PC - Counter for Drawing Screen
ULONG WindowBitmap[5472];
ULONG * baseAddr;
int YOffset;

int Screen_Init (void)
{
    ScreenBits=CreateCompatibleDC(MainWndDC);
    ScreenBitmapH=CreateBitmap(512,342,1,1,WindowBitmap);

    Screen_Reset();

    return 0;
}

void Screen_Refresh(void)
{
    UpdateScreen=1;
    WindowBitmap[0]=22;
    return;
}

UBYTE VRAM_Main_GetB (CPTR addr)
{
   return VRAM_Main [addr >> 1] >> (addr & 1 ? 0 : 8);
}

UWORD VRAM_Main_GetW (CPTR addr)
{
   return VRAM_Main [addr >> 1];
}

ULONG VRAM_Main_GetL (CPTR addr)
{
   return ((ULONG) VRAM_Main [addr >> 1] << 16) | VRAM_Main [(addr >> 1)+1];
}

void VRAM_Main_PutB (CPTR addr, UBYTE in)
{
   if (!(addr & 1)) {
      VRAM_Main [addr >> 1] = (VRAM_Main [addr >> 1] & 0xff) | (((UWORD) in) << 8);
   } else {
      VRAM_Main [addr >> 1] = (VRAM_Main [addr >> 1] & 0xff00) | in;
   }

   if (thePrefs.Big==1)  addr+=0x1598;

   WindowBitmap[addr]=in | (WindowBitmap[addr] & 0xFFFFFF00);
   UpdateScreen=1;

   return;
}

void VRAM_Main_PutW (CPTR addr, UWORD in)
{
   VRAM_Main [addr >> 1] = in;

   if (thePrefs.Big==1)  addr+=0x1598;

/*
   asm
   {
   mov    ax, in
   xchg   ah, al  //                         endian conversion
   not    ax      //                          color switch [black<->white>]
   //write ax to window bitmap...
   }
*/

   WindowBitmap[addr]=in | (WindowBitmap[addr] & 0xFFFF0000);
   UpdateScreen=1;

   return;
}

void VRAM_Main_PutL (CPTR addr, ULONG in)
{
   VRAM_Main [addr >> 1] = in >> 16;
   VRAM_Main [(addr >> 1) + 1] = (UWORD) in;

   if (thePrefs.Big==1)  addr+=0x1598;

   WindowBitmap[addr]=in;
   UpdateScreen=1;

   return;
}

UBYTE VRAM_Alt_GetB (CPTR addr)
{
   return 0;
}

UWORD VRAM_Alt_GetW (CPTR addr)
{
   return 0;
}

ULONG VRAM_Alt_GetL (CPTR addr)
{
   return 0;
}

void VRAM_Alt_PutB (CPTR addr, UBYTE in)
{
   return;
}

void VRAM_Alt_PutW (CPTR addr, UWORD in)
{
   return;
}

void VRAM_Alt_PutL (CPTR addr, ULONG in)
{
   return;
}

void Screen_Draw(void)
{
    if(!baseAddr)
        return;

    if(thePrefs.DX)
    {
        DX_DrawBW(baseAddr);
        return;
    }

    if(FastMemCmpCpy(WindowBitmap,baseAddr,5472) && !UpdateScreen && !ROMScreen)
        return;

    SetBitmapBits(ScreenBitmapH,21888,baseAddr);
    SelectObject(ScreenBits,ScreenBitmapH);
    BitBlt(MainWndDC,XBorder,YOffset,512,342,ScreenBits,0,0,NOTSRCCOPY);

    return;
}

void Screen_Reset (void)
{
    if (vPage2 == 1)
        baseAddr = RAM_Xlate(kMain_Buffer);
    else
        baseAddr = RAM_Xlate(kAlternate_Buffer);

    YOffset=YMenu+YBorder+YMenuSize+32-1;

    Screen_Refresh();

    ROMScreen=1;

    return;
}

// VIA Interface Functions

UBYTE VIA_GORA6 (void) // Main/Alternate Screen Buffer
{
  #ifdef _VIA_Interface_Debug
  fprintf(DebugMsgFile,"VIA ORA6 attempts to be an input\n");
  #endif
  return 0;
}

void  VIA_PORA6 (UBYTE Data)
{
  vPage2 = Data;

  Screen_Reset();
}

UBYTE VIA_GORB6 (void) // Video Beam in Display
{
  return 0; // Assume it is
}

void  VIA_PORB6 (UBYTE Data)
{
  #ifdef _VIA_Interface_Debug
  fprintf(DebugMsgFile,"VIA ORB6 attempts to be an output\n");
  #endif
}
