#include "sysconfig.h"
#include "sysdeps.h"
#include "config.h"
#include "options.h"
#include "machdep\m68k.h"
#include "memory.h"
#include "uae_vmac_patch.h"
#include "vMac_custom.h"
#include "readcpu.h"
#include "newcpu.h"
#include "compiler.h"
#include "cputbl.h"
#include "custom.h"
#include "Prefs.h"
#include "keyboard.h"
#include "ROM.h"
#include "mouse.h"
#include "includes\memory.h"
#include "Win32Port.h"
#include "Screen.h"
#include "Sound.h"
#include <win32\dbt.h> //Take out the "win32\" if not using Symantec C++
#include <math.h>
#include <direct.h>

//Globals

//#define _Win32_Debug

#define IDC_TOOLBAR (WM_USER+1)
int ToolSelect=0;
BOOL bPaused=FALSE;
BOOL DXMenu=FALSE;
HWND hwndSplash=NULL;
static HWND hwndToolbar;

char WndTitle[256];
char WndClassName[256];

int MacAppLen;
char MacApp[32], WindowTitle[256], OldWindowTitle[256];

char vMacStatus[256];

HANDLE NTCDHandle;
int KeyMod=0;
BYTE KeyDown=0;
char vMacOpenFile[1024];
BYTE ClipMouse=0;
int ScreenFPS=25;
LONG CmdShow;
int iSoundCounts=0;
HWAVEOUT hWaveOut;
BOOL     g_bSound=FALSE;
UINT uTimeID_60th;
UINT DrawScreenID;
#define ciSound_Buffers 3

WAVEHDR   whdr[ciSound_Buffers];
int       iSound_Buffer=0;
BOOL      iSound_BuffersAvailable=ciSound_Buffers;
OSVERSIONINFO OSVerInfo;
BOOL      Sound_22kHz=TRUE;

int vMacQuit=0;

int MouseX, MouseY;
int PrevMouseX, PrevMouseY;
POINT MousePos;

#ifdef _Win32_Debug
  FILE * DebugFile;
#endif

extern Sound_Ty Sound;

TBBUTTON tbButtons[10]=
{
{ 0, 0,                    TBSTATE_ENABLED, TBSTYLE_SEP,    0, 0 },
{ 0, ID_FILE_INSERTDISK1,  TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0 },
{ 1, ID_FILE_INSERTDISK2,  TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0 },
{ 2, ID_FILE_INSERTFLOPPY, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0 },
{ 0, 0,                    TBSTATE_ENABLED, TBSTYLE_SEP,    0, 0 },
{ 3, ID_CONTROL_RESET,     TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0 },
{ 4, ID_CONTROL_INTERRUPT, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0 },
{ 5, ID_CONTROL_PAUSE,     TBSTATE_ENABLED, TBSTYLE_CHECK,  0, 0 },
{ 0, 0,                    TBSTATE_ENABLED, TBSTYLE_SEP,    0, 0 },
{ 6, ID_HELP_ABOUT,        TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0 }
};

//Prototypes
void SizeClient(HWND hWnd, int iX, int iY);
void CALLBACK TimeProc_60(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2);
void CALLBACK DrawScreen(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2);
void CALLBACK WaveCallback(HWAVEOUT hwo, UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2);
static void WaveClose(void);
void Wave_Write(BYTE *byBuffer, BOOL bSilent, int iSlot);
void Wave_Play(void);
BOOL Win32InitApplication(HINSTANCE hInstance);
BOOL Win32InitInstance(HINSTANCE hInstance, LONG nCmdShow);
ULONG Win32KeyRemap(ULONG key, UWORD modifier);
BOOL Bit(ULONG TempMem, int BitNum);
BYTE Win32OpenDSK(void);
void InsertDSK1(void);
void InsertDSK2(void);
void MouseClip(int Setting);
void vMacWin32Quit(void);
void RegisterClassSplash();
HWND CreateWindow_Splash(HWND hwndMain);
void SetSplashTime (int st);
void VxdPatchOnOff( int onoff );

DWORD WINAPI FloppyThread(LPVOID *pVoid);
DWORD WINAPI ModemThread(LPVOID *pVoid);
DWORD WINAPI PrintThread(LPVOID *pVoid);
void ResetComm(int Device);

LONG WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, LONG nCmdShow)
{
    PHKEY RegKey;
    PHKEY RegKey2;
    int Temp=4;

    /* Set window title, and use it for the class name too */
    strcpy(WndTitle,"vMac 0.1.9.6 for Win32");
    strcpy(WndClassName,"vMac");

    UpdateDXScreen(TRUE);

    Mac_Interrupt=Mac_Reset=0;

    Int60=Int1=0;
    MouseButton=0;
    ROMScreen=UpdateScreen=1;
    ShowTraps=FloppyReady=FloppyBusy=FALSE;

    YMenuSize=GetSystemMetrics(SM_CYCAPTION);
    YMenu=GetSystemMetrics(SM_CYMENU);
    XBorder=GetSystemMetrics(SM_CXFIXEDFRAME);
    YBorder=GetSystemMetrics(SM_CYFIXEDFRAME)-1;
    ScreenX=GetSystemMetrics(SM_CXSCREEN);
    ScreenY=GetSystemMetrics(SM_CYSCREEN);

    OSVerInfo.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
    GetVersionEx(&OSVerInfo);
    if (OSVerInfo.dwPlatformId==VER_PLATFORM_WIN32s)
    {
        //Show Win32s notice and quit. vMac Win32
        //runs very poorly under Win32s. Win32s is
        //for running 32-bit Windows apps on 16-bit
        //Windows (Windows 3.1/3.11).
        vMac_Message("Sorry, vMac for Win32 requires a true 32 bit version of Windows, such as Windows 95 or NT");
        ExitProcess(1);
    }

    AppInstance = hInstance;
    CmdShow = nCmdShow;

    RegisterClassSplash();

    if (!hPrevInstance)
        if (!Win32InitApplication(AppInstance))
            return FALSE;

    if (!Win32InitInstance(AppInstance, CmdShow))
        return FALSE;

    //Get FPS from registry
    RegOpenKeyEx(HKEY_LOCAL_MACHINE,"SOFTWARE\\vMac\0", 0, KEY_QUERY_VALUE, &RegKey);
    RegQueryValueEx(RegKey,"FPS\0",NULL,NULL,&ScreenFPS,&Temp);
    RegCloseKey(RegKey);


    if (OSVerInfo.dwPlatformId==VER_PLATFORM_WIN32_NT)
        CdenableSysInstallStart();
    else
        VxdPatchOnOff(TRUE);

    #ifdef _Win32_Debug
      DebugFile=fopen("Debug.txt","w+");
    #endif

    _getcwd(vMacPath,1000);
    strcpy(PrefsFile,vMacPath);
    strcpy(&PrefsFile[strlen(PrefsFile)], "\\vMac.ini");

    PrefsLoad(PrefsFile);

    ReadModem=ReadPrint=0;

    //Start
    hFloppyThread=CreateThread(NULL, 0, FloppyThread, NULL, 0, &FloppyThreadID);
    hModemThread=CreateThread(NULL, 0, ModemThread, NULL, 0, &ModemThreadID);
    hPrintThread=CreateThread(NULL, 0, PrintThread, NULL, 0, &PrintThreadID);

    Sleep(250);
    main1(0,lpCmdLine);

    vMacWin32Quit();

    #ifdef _Win32_Debug
      fclose(DebugFile);
    #endif

    //ExitProcess(0);
    return(0);
}

void ResetComm(int Device)
{
    COMMTIMEOUTS DeviceTimeOuts;
    DCB DeviceDCB;

    if(Device==1)
    {
        if(thePrefs.ModemPort==0)
        {
            ModemPort=0;
            return;
        }
        else
        {
            char ModemString[5];

            if(ModemPort && thePrefs.ModemPort<=7)
            {
                CloseHandle(ModemPort);
                ModemPort=0;
            }

            if(thePrefs.ModemPort<=4)
                wsprintf(ModemString,"COM%d",thePrefs.ModemPort);
            else if(thePrefs.ModemPort<=7)
                wsprintf(ModemString,"LPT%d",thePrefs.ModemPort-4);
            else if(thePrefs.ModemPort==8)
                wsprintf(ModemString,"Modem.out");
            else
                return;

            if(thePrefs.ModemPort!=8)
                ModemPort=CreateFile(ModemString,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_OVERLAPPED,NULL);
            else
                ModemPort=CreateFile(ModemString,GENERIC_READ|GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);

            if(!ModemPort)
            {
                ModemPort=0;
                //vMac_Message("Couldn't open ModemPort");
                return;
            }

            if(thePrefs.ModemPort<=7)
            {
                SetCommMask(ModemPort,EV_RXCHAR);
                SetupComm(ModemPort,8192,256);
            }
            else
                return; //We're done, if FILE or MODEM
        }
    }
    else
    {
        if(thePrefs.PrintPort==0)
        {
            PrintPort=0;
            return;
        }
        else
        {
            char PrintString[5];

            if(PrintPort && thePrefs.PrintPort<=7)
            {
                CloseHandle(PrintPort);
                PrintPort=0;
            }

            if(thePrefs.PrintPort<=4)
                wsprintf(PrintString,"COM%d",thePrefs.PrintPort);
            else if(thePrefs.PrintPort<=7)
                wsprintf(PrintString,"LPT%d",thePrefs.PrintPort-4);
            else if(thePrefs.PrintPort==8)
                wsprintf(PrintString,"Print.out");
            else
                return;

            if(thePrefs.PrintPort!=8)
                PrintPort=CreateFile(PrintString,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_OVERLAPPED,NULL);
            else
                PrintPort=CreateFile(PrintString,GENERIC_READ|GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);

            if(!PrintPort)
            {
                PrintPort=0;
                //vMac_Message("Couldn't open PrintPort");
                return;
            }

            if(thePrefs.PrintPort<=7)
            {
                SetCommMask(PrintPort,EV_RXCHAR);
                SetupComm(PrintPort,8192,256);
            }
            else
                return; //We're done, if FILE or PRINT
        }
    }

    DeviceDCB.DCBlength=sizeof(DCB);

    BuildCommDCB("COM1:9600,n,8,1",&DeviceDCB);
    //COM1 (above) isn't used, but a valid port is required

    DeviceDCB.fAbortOnError=FALSE;
    DeviceDCB.fBinary=TRUE;
    DeviceDCB.fParity=TRUE;
    DeviceDCB.fDtrControl=DTR_CONTROL_ENABLE;
    DeviceDCB.fRtsControl=RTS_CONTROL_ENABLE;

    if(Device==1)
    {
        DWORD ModemError;
        ClearCommError(ModemPort,&ModemError,NULL);
        ClearCommBreak(ModemPort);
        SetCommState(ModemPort,&DeviceDCB);
    }
    else
    {
        DWORD PrintError;
        ClearCommError(PrintPort,&PrintError,NULL);
        ClearCommBreak(PrintPort);
        SetCommState(PrintPort,&DeviceDCB);
    }

    DeviceTimeOuts.ReadIntervalTimeout=MAXDWORD;
    DeviceTimeOuts.ReadTotalTimeoutMultiplier=0;
    DeviceTimeOuts.ReadTotalTimeoutConstant=0;
    DeviceTimeOuts.WriteTotalTimeoutMultiplier=0;
    DeviceTimeOuts.WriteTotalTimeoutConstant=0;

    if(Device==1)
        SetCommTimeouts(ModemPort,&DeviceTimeOuts);
    else
        SetCommTimeouts(PrintPort,&DeviceTimeOuts);

    return;
}

DWORD WINAPI FloppyThread(LPVOID *pVoid)
{
    int FloppyTime=1000*thePrefs.AutoInsert;

	SetThreadPriority(hFloppyThread, THREAD_PRIORITY_IDLE);

    while(!StopEmulation && (ROMScreen || !FloppyReady))
        Sleep(5000);

    if(!thePrefs.AutoInsert || !thePrefs.Floppy || !UseFloppy)
        return(0);

	while(!StopEmulation && UseFloppy)
    {
        Sleep(FloppyTime);

        if(ROMScreen || !FloppyReady || bPaused || Sony_Disk_Inserted(1))
        {
            Sleep(5000);
            continue;
        }

        if(dcheck()!=0x80)
            Sony_Insert(1, NULL);
    }

    return(0);
}

DWORD WINAPI ModemThread(LPVOID *pVoid)
{
    DWORD ModemStat;
    int Result, Count;
    OVERLAPPED ModemOverlap;

    ModemCount=ModemBytes=0;
    ModemOverlap.Offset=0;

    SetThreadPriority(hModemThread, THREAD_PRIORITY_LOWEST);

    ResetComm(1);

    if(thePrefs.ModemPort>7)
        return(0); //This thread isn't for FILE or MODEM

    while(!StopEmulation && ModemPort)
    {
        if(WaitCommEvent(ModemPort,&ModemStat,&ModemOverlap))
        {
ReadModemData:
            if(ReadFile(ModemPort,ModemData,256,&ModemBytes,&ModemOverlap) && ModemBytes)
            {
                ReadModem=1;
                ModemCount=0;

                while(ModemBytes)
                {
                    //Wait for buffer to be read
                    if(ReadModem==0)
                        ReadModem=1;

                    Sleep(0);
                }

                ModemCount=ModemBytes=ReadModem=0;

                goto ReadModemData;
            }
        }
    }

    return(0);
}

DWORD WINAPI PrintThread(LPVOID *pVoid)
{
    DWORD PrintStat;
    int Result, Count;
    OVERLAPPED PrintOverlap;

    PrintCount=PrintBytes=0;
    PrintOverlap.Offset=0;

    SetThreadPriority(hPrintThread, THREAD_PRIORITY_LOWEST);

    ResetComm(2);

    if(thePrefs.PrintPort>7)
        return(0); //This thread isn't for FILE or MODEM

    while(!StopEmulation && PrintPort)
    {
        if(WaitCommEvent(PrintPort,&PrintStat,&PrintOverlap))
        {
ReadPrintData:
            if(ReadFile(PrintPort,PrintData,256,&PrintBytes,&PrintOverlap) && PrintBytes)
            {
                ReadPrint=1;
                PrintCount=0;

                while(PrintBytes)
                {
                    //Wait for buffer to be read
                    if(ReadPrint==0)
                        ReadPrint=1;

                    Sleep(0);
                }

                PrintCount=PrintBytes=ReadPrint=0;

                goto ReadPrintData;
            }
        }
    }

    return(0);
}

void vMacWin32Quit(void)
{
    PHKEY RegKey;
    PHKEY RegKey2;

    if(vMacQuit)
        return;

    vMacQuit=1;
    StopEmulation=1;

    ClipMouse=0;
    ClipCursor(NULL);

    if(ModemPort)
        CloseHandle(ModemPort);
    if(PrintPort)
        CloseHandle(PrintPort);

    RegOpenKeyEx(HKEY_LOCAL_MACHINE,"SOFTWARE\0", 0, KEY_ALL_ACCESS, &RegKey);
    RegCreateKeyEx(RegKey,"vMac", 0, WndClassName,REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL,&RegKey2,NULL);

    WndX-=XBorder;
    WndY-=YMenuSize+YMenu+YBorder+1;

    if (WndX<0 || WndY<0 || WndX>ScreenX || WndY>ScreenY)
     {}
    else
      if(thePrefs.DX==0 && vMacError==0) //Save WndX and WndY in registry
       {
        RegSetValueEx(RegKey2,"WndX\0",0,REG_DWORD,&WndX,4);
        RegSetValueEx(RegKey2,"WndY\0",0,REG_DWORD,&WndY,4);
       }

    //Save FPS in registry
    RegSetValueEx(RegKey2,"FPS\0",0,REG_DWORD,&ScreenFPS,4);

    RegCloseKey(RegKey2);
    RegCloseKey(RegKey);

    KillTimer(MainWnd,1);
    timeKillEvent(DrawScreenID);
    timeKillEvent(uTimeID_60th);

    if(g_bSound)
        WaveClose();

    ReleaseDC(MainWnd,MainWndDC);
    DeleteDC(ScreenBits);

    if(thePrefs.Floppy)
        dfinal();

    if(UseCD==1)
    {
        CDfinal();
        if(NTCDHandle!=NULL && OSVerInfo.dwPlatformId==VER_PLATFORM_WIN32_NT)
            CloseHandle(NTCDHandle);
    }

    if(MainWnd)
        PostQuitMessage(0);

    if(hFloppyThread)
        TerminateThread(hFloppyThread,0);
    if(hModemThread)
        TerminateThread(hModemThread,0);
    if(hPrintThread)
        TerminateThread(hPrintThread,0);

    if(hThread_CPU)
        TerminateThread(hThread_CPU,0);

    return;
}

void SetStatus(char * String)
{
    strcpy(vMacStatus,String);
    return;
}

/* These are global to improve speed in FastMemCmpCpy() */
ULONG MemCount;
BOOL Match;

BOOL FastMemCmpCpy(ULONG * Dest, ULONG * Source, ULONG Len)
{
    /*
      This compares two arrays of 32-bit variables,
      and returns TRUE if they match, otherwise it
      copies Source to Dest and returns FALSE.
    */

    /* Compare until a difference is found */
    for(Match=TRUE,MemCount=0;MemCount!=Len;++MemCount)
        if(Dest[MemCount]!=Source[MemCount])
        {
            Match=FALSE;
            Dest[MemCount]=Source[MemCount];
            break;
        }

    /* If they don't match, then copy Source to Dest */
    if(!Match)
        for(;MemCount!=Len;++MemCount)
            Dest[MemCount]=Source[MemCount];

    return(Match);
}

void SizeClient(HWND hWnd, int iX, int iY)
{
   RECT rcWindow;

   int iXWidth, iYWidth;

   GetWindowRect(hWnd, &rcWindow);

   iXWidth=(rcWindow.right-rcWindow.left)+iX-(g_rcClient.right-g_rcClient.left);
   iYWidth=(rcWindow.bottom-rcWindow.top)+iY-(g_rcClient.bottom-g_rcClient.top);

   SetWindowPos(hWnd, 0, 0, 0, iXWidth, iYWidth, SWP_NOZORDER|SWP_NOMOVE);
}

void CALLBACK DrawScreen(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
    GetCursorPos(&MousePos);

    if(thePrefs.DX)
    {
        MouseX=MousePos.x-64; //((640-512)/2)
        MouseY=MousePos.y-69; //((480-342)/2)
    }
    else
    {
        MouseX=MousePos.x-WndX;
        MouseY=MousePos.y-WndY-31;
    }

    if(MouseX!=PrevMouseX || MouseY!=PrevMouseY)
    {
       PrevMouseX=MouseX;
       PrevMouseY=MouseY;

       if((MouseX>=0 && MouseX<=511) && (MouseY>=0 && MouseY<=341))
           Mouse_Update2(MouseX, MouseY);
    }

//    if(!UpdateScreen && !ROMScreen)
//        return;

    Screen_Draw();
    UpdateScreen=0;

    return;
}

void CALLBACK TimeProc_60(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
    if(g_bSound)
    {
        if(iSound_BuffersAvailable && iSoundCounts==10)
        {
            Wave_Play();
            iSoundCounts=0;
        }

        if(iSoundCounts<10)
            Wave_Write((BYTE *)RAM_Xlate(Sound.Buffer ? Sound_Base : Sound_Alternate),
                       Sound.Enable, iSoundCounts++);
    }

    Int60=1;

    return;
}

LRESULT CALLBACK Win32WMProc(HWND MainWnd, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
    switch (uMessage)
    {
        case WM_MOUSEMOVE:
            if(thePrefs.DX)
                break;

            if(bPaused)
            {
                SetCursor(LoadCursor(NULL,IDC_ARROW));
                break;
            }

            if((HIWORD(lparam)<31 || HIWORD(lparam)>372))
                SetCursor(LoadCursor(NULL,IDC_ARROW));
            else
                SetCursor(NULL);

            break;

        case WM_TIMER:
            if(!thePrefs.DX)
            {
                if(g_bSound && thePrefs.Sound)
                {
                    if(Sound_22kHz)
                        SendMessage(hwndStatus, SB_SETTEXT, 2, (LPARAM) "Sound: 22");
                    else
                        SendMessage(hwndStatus, SB_SETTEXT, 2, (LPARAM) "Sound: 11");
                }
                else
                    SendMessage(hwndStatus, SB_SETTEXT, 2, (LPARAM) "Sound: OFF");

                if(bPaused)
                    SendMessage(hwndStatus, SB_SETTEXT, 5, (LPARAM) "Paused");
                else
                    SendMessage(hwndStatus, SB_SETTEXT, 5, (LPARAM) "");

                if(thePrefs.CurrentROMPath==255)
                    SendMessage(hwndStatus, SB_SETTEXT, 3, (LPARAM) "Hardware ROM");

                if(ModemPort && PrintPort)
                    SendMessage(hwndStatus, SB_SETTEXT, 4, (LPARAM) "SCC: A+B");
                else if(ModemPort && !PrintPort)
                    SendMessage(hwndStatus, SB_SETTEXT, 4, (LPARAM) "SCC: A");
                else if(!ModemPort && PrintPort)
                    SendMessage(hwndStatus, SB_SETTEXT, 4, (LPARAM) "SCC: B");
                else
                    SendMessage(hwndStatus, SB_SETTEXT, 4, (LPARAM) "");

//                SendMessage(hwndStatus, SB_SETTEXT, 3, (LPARAM)"Disks are idle");


                strcpy(WindowTitle,WndTitle);

                MacAppLen=get_byte(0x910);

                if(MacAppLen>0 && MacAppLen<32)
                {
                    memcpy(MacApp,get_real_address(0x911),MacAppLen);
                    MacApp[MacAppLen]=0;
                    wsprintf(WindowTitle,"%s - %s",MacApp,WndTitle);
                }
                else
                    strcpy(WindowTitle,WndTitle);

                if(vMacStatus[0])
                    sprintf(WindowTitle,"%s (%s)", WindowTitle, vMacStatus);

                if(strcmp(WindowTitle,OldWindowTitle)!=0)
                {
                    SetWindowText(MainWnd,WindowTitle);
                    strcpy(OldWindowTitle,WindowTitle);
                }

                UpdateWindow(hwndStatus);
                UpdateWindow(hwndToolbar);
                UpdateWindow(MainWnd);
            }

           Int1=1;
        break;

        case WM_LBUTTONDOWN:
            if(!thePrefs.DX)
            {
                SetCapture(MainWnd);

                if((LOWORD(lparam)<0 || LOWORD(lparam)>511) || (HIWORD(lparam)<=0+32 || HIWORD(lparam)>=341+32))
                {
                    int X=LOWORD(lparam),Y=HIWORD(lparam);

                    if(Y>=3 && Y<=25)
                    {
                        if(X>=9 && X<=31)
                        {
                            SendMessage(hwndToolbar, TB_CHECKBUTTON, ID_FILE_INSERTDISK1, TRUE);
                            ToolSelect=ID_FILE_INSERTDISK1;
                        }

                        if(X>=32 && X<=56)
                        {
                            SendMessage(hwndToolbar, TB_CHECKBUTTON, ID_FILE_INSERTDISK2, TRUE);
                            ToolSelect=ID_FILE_INSERTDISK2;
                        }

                        if(X>=57 && X<=81)
                        {
                            SendMessage(hwndToolbar, TB_CHECKBUTTON, ID_FILE_DISKCD, TRUE);
                            ToolSelect=ID_FILE_DISKCD;
                        }

                        if(X>=90 && X<=114)
                        {
                            SendMessage(hwndToolbar, TB_CHECKBUTTON, ID_CONTROL_RESET, TRUE);
                            ToolSelect=ID_CONTROL_RESET;
                        }

                        if(X>=115 && X<=139)
                        {
                            SendMessage(hwndToolbar, TB_CHECKBUTTON, ID_CONTROL_INTERRUPT, TRUE);
                            ToolSelect=ID_CONTROL_INTERRUPT;
                        }

                        if(X>=140 && X<=164)
                        {
                            SendMessage(hwndToolbar, TB_CHECKBUTTON, ID_CONTROL_PAUSE, TRUE);
                            ToolSelect=ID_CONTROL_PAUSE;
                        }

                        if(X>=173 && X<=197)
                        {
                            SendMessage(hwndToolbar, TB_CHECKBUTTON, ID_HELP_ABOUT, TRUE);
                            ToolSelect=ID_HELP_ABOUT;
                        }

                        UpdateWindow(hwndToolbar);
                    }
                    break;
                }
            }

            if(DXMenu==TRUE)
            {
                ClipMouse=1;
                bPaused=FALSE;
                DXMenu=FALSE;
                DX_CleanBuffers();
            }

            if(thePrefs.DX)
            {
                UpdateDXScreen(TRUE);
                ClipMouse=1;
            }

            MouseButton=1;
            MouseClip(1);
            break;

        case WM_LBUTTONUP:
            if(!thePrefs.DX)
                ReleaseCapture();

            if((!thePrefs.DX && ToolSelect) && ((LOWORD(lparam)<0 || LOWORD(lparam)>511) || (HIWORD(lparam)<=0+32 || HIWORD(lparam)>=341+32)))
            {
                int X=LOWORD(lparam),Y=HIWORD(lparam);

                SendMessage(hwndToolbar, TB_CHECKBUTTON, ToolSelect, FALSE);

                if(Y>=3 && Y<=25)
                {
                    if(X>=9 && X<=31 && ToolSelect==ID_FILE_INSERTDISK1)
                        SendMessage(MainWnd,WM_COMMAND,ID_FILE_INSERTDISK1,NULL);

                    if(X>=32 && X<=56 && ToolSelect==ID_FILE_INSERTDISK2)
                        SendMessage(MainWnd,WM_COMMAND,ID_FILE_INSERTDISK2,NULL);

                    if(X>=57 && X<=81 && ToolSelect==ID_FILE_DISKCD)
                        SendMessage(MainWnd,WM_COMMAND,ID_FILE_DISKCD,NULL);

                    if(X>=90 && X<=114 && ToolSelect==ID_CONTROL_RESET)
                        SendMessage(MainWnd,WM_COMMAND,ID_CONTROL_RESET,NULL);

                    if(X>=115 && X<=139 && ToolSelect==ID_CONTROL_INTERRUPT)
                        SendMessage(MainWnd,WM_COMMAND,ID_CONTROL_INTERRUPT,NULL);

                    if(X>=140 && X<=164 && ToolSelect==ID_CONTROL_PAUSE)
                        SendMessage(MainWnd,WM_COMMAND,ID_CONTROL_PAUSE,NULL);

                    if(X>=173 && X<=197 && ToolSelect==ID_HELP_ABOUT)
                        SendMessage(MainWnd,WM_COMMAND,ID_HELP_ABOUT,NULL);
                }

                UpdateWindow(hwndToolbar);
                break;
            }

            MouseButton=0;
            MouseClip(0);
            break;

        case WM_SYSKEYDOWN:
            if(wparam==VK_F4) //Alt F4
             {StopEmulation=1;
              PostQuitMessage(1);}

            if(wparam==VK_RETURN) //Alt Enter - Toggle DirectX mode
                FORWARD_WM_COMMAND(MainWnd, ID_FILE_DIRECTX, NULL, 0, PostMessage);

           if (thePrefs.KeyConfig==3)
           {
            if(wparam==VK_SHIFT)
             {KeyMod|=0x0200;
              Keyboard_UpdateKeyMap(0x38, TRUE);}

            if(wparam==VK_CAPITAL)
             {KeyMod|=0x0400;
              Keyboard_UpdateKeyMap(0x39, TRUE);}

            if(wparam==VK_CONTROL)
             {KeyMod|=0x1000; //Control
              Keyboard_UpdateKeyMap(0x3b, TRUE);}

            if(Bit(lparam,24))
            {
                //Right Alt
                KeyMod|=0x0800; //Option
                Keyboard_UpdateKeyMap(0x3a, TRUE);
            }
            else
            {
                //Left Alt
                KeyMod|=0x0100; //Command
                Keyboard_UpdateKeyMap(0x37, TRUE);
            }

            KeyDown=1;
            wparam=Win32KeyRemap(wparam, KeyMod);
            if(wparam==0)
                break;
            Keyboard_Down(wparam, KeyMod);
           }

           if (thePrefs.KeyConfig==2)
           {
            if(wparam==VK_CONTROL)
             {KeyMod|=0x0800; //Option
              Keyboard_UpdateKeyMap(0x3a, TRUE);}

            if(wparam==VK_SHIFT)
             {KeyMod|=0x0200;
              Keyboard_UpdateKeyMap(0x38, TRUE);}

            if(wparam==VK_CAPITAL)
             {KeyMod|=0x0400;
              Keyboard_UpdateKeyMap(0x39, TRUE);}

            KeyMod|=0x0100; //Command
            Keyboard_UpdateKeyMap(0x37, TRUE);

            KeyDown=1;
            wparam=Win32KeyRemap(wparam, KeyMod);
            if(wparam==0)
                break;
            Keyboard_Down(wparam, KeyMod);
           }

            break;

        case WM_SYSKEYUP:
            if(wparam==VK_F4) //Alt F4
                StopEmulation=1;

           if (thePrefs.KeyConfig==3)
           {
            if(wparam==VK_SHIFT)
             {KeyMod&=~0x0200;
              Keyboard_UpdateKeyMap(0x38, FALSE);}

            if(wparam==VK_CAPITAL)
             {KeyMod&=~0x0400;
              Keyboard_UpdateKeyMap(0x39, FALSE);}

            if(wparam==VK_CONTROL)
             {KeyMod&=~0x1000; //Control
              Keyboard_UpdateKeyMap(0x3b, FALSE);}

            if(Bit(lparam,24))
            {
                //Right Alt
                KeyMod&=~0x0800; //Option
                Keyboard_UpdateKeyMap(0x3a, FALSE);
            }
            else
            {
                //Left Alt
                KeyMod&=~0x0100; //Command
                Keyboard_UpdateKeyMap(0x37, FALSE);
            }

            KeyDown=1;
            wparam=Win32KeyRemap(wparam, KeyMod);
            if(wparam==0)
                break;
            Keyboard_Down(wparam, KeyMod);
           }

           if (thePrefs.KeyConfig==2)
           {
            if(wparam==VK_CONTROL)
             {KeyMod&=~0x0800; //Option
              Keyboard_UpdateKeyMap(0x3a, FALSE);}

            if(wparam==VK_SHIFT)
             {KeyMod&=~0x0200;
              Keyboard_UpdateKeyMap(0x38, FALSE);}

            if(wparam==VK_CAPITAL)
             {KeyMod&=~0x0400;
              Keyboard_UpdateKeyMap(0x39, FALSE);}

            KeyMod&=~0x0100; //Command
            Keyboard_UpdateKeyMap(0x37, FALSE);

            KeyDown=0;
            wparam=Win32KeyRemap(wparam, KeyMod);
            if(wparam==0)
                break;
            Keyboard_Up(wparam, KeyMod);
           }
            break;

        case WM_KEYDOWN:
            switch(wparam)
            {
               case VK_F1:
                   FORWARD_WM_COMMAND(MainWnd, ID_FILE_INSERTDISK1, NULL, 0, PostMessage);
                   break;

               case VK_F2:
                   FORWARD_WM_COMMAND(MainWnd, ID_FILE_INSERTDISK2, NULL, 0, PostMessage);
                   break;

               case VK_F3:
                  //Insert a 1.4MB Mac floppy and/or Mac CD-ROM
                  Sony_Insert(1, NULL);
                  Sony_Insert(4, NULL);
                  break;

               case VK_F4:
                  //Toggle DirectX mode
                  FORWARD_WM_COMMAND(MainWnd, ID_FILE_DIRECTX, NULL, 0, PostMessage);
                  break;

               case VK_F5:
               {
                    //Debug info
                    OSVERSIONINFO OSVerInfo;
                    char Temp[1024];
                    char OS[256];

                    OSVerInfo.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
                    GetVersionEx(&OSVerInfo);

                    if(OSVerInfo.dwPlatformId==VER_PLATFORM_WIN32_WINDOWS)
                    {
                        if(OSVerInfo.dwMajorVersion==4 && OSVerInfo.dwMinorVersion==0)
                            strcpy(OS,"95 ");
                        else if(OSVerInfo.dwMajorVersion==4 && OSVerInfo.dwMinorVersion==10)
                            strcpy(OS,"98 ");
                        else
                            strcpy(OS,"9x ");

                        wsprintf(&OS[strlen(OS)],"%d.%d Build %d %s", OSVerInfo.dwMajorVersion, OSVerInfo.dwMinorVersion, LOWORD(OSVerInfo.dwBuildNumber), OSVerInfo.szCSDVersion);
                    }
                    else
                    {
                        strcpy(OS,"NT ");
                        wsprintf(&OS[strlen(OS)],"%d.%d Build %d %s", OSVerInfo.dwMajorVersion, OSVerInfo.dwMinorVersion, OSVerInfo.dwBuildNumber, OSVerInfo.szCSDVersion);
                    }

                    wsprintf(Temp,"DEBUG INFO (If you are having problems, send this to Weston@vMac.org)\n\nUseFloppy=%d, UseCD=%d, Sound=%d, Sound_22kHz=%d, DirectX=%d, KeyConfig=%d, RAMSize=%d, AutoQuit=%d, Floppy=%d, CD=%d, CDdrive=%d, ModemPortEnabled=%d, ModemPort=%d, PrintPortEnabled=%d, PrintPort=%d, ROMVer=%d, OS=%s, vMac Version=%s", UseFloppy, UseCD, thePrefs.Sound, Sound_22kHz, thePrefs.DX, thePrefs.KeyConfig, thePrefs.RAMSize, thePrefs.AutoQuit, thePrefs.Floppy, thePrefs.CD, CDdrive, (ModemPort!=0), thePrefs.ModemPort, (PrintPort!=0), thePrefs.PrintPort, ROM_GetVer(), OS, WndTitle);
                    vMac_Message(Temp);

                    break;
               }

/*
               case VK_F6:
                  //Toggle Trap Debug Info
                  ShowTraps=!ShowTraps;
*/
                  break;

               case VK_CONTROL:
                  if(thePrefs.KeyConfig==3)
                   {
                    KeyMod|=0x1000; //Control
                    Keyboard_UpdateKeyMap(0x3b, TRUE);
                    break;
                   }

                  if(thePrefs.KeyConfig==2)
                   {
                    KeyMod|=0x0800; //Option
                    Keyboard_UpdateKeyMap(0x3a, TRUE);
                    break;
                   }

                  if(Bit(lparam,24))
                  {
                    //Right Control
                    if(thePrefs.KeyConfig==1)
                     {KeyMod|=0x0800; //Option
                      Keyboard_UpdateKeyMap(0x3a, TRUE);}
                  }
                  else
                  {
                    //Left Control
                    if(thePrefs.KeyConfig==1)
                     {KeyMod|=0x0100; //Command
                      Keyboard_UpdateKeyMap(0x37, TRUE);}
                  }

                  break;

               case VK_SHIFT:
                  KeyMod|=0x0200;
                  Keyboard_UpdateKeyMap(0x38, TRUE);
                  break;

               case VK_CAPITAL:
                  KeyMod|=0x0400;
                  Keyboard_UpdateKeyMap(0x39, TRUE);
                  break;

               default:
                  KeyDown=1;
                  wparam=Win32KeyRemap(wparam, KeyMod);
                  if(wparam==0)
                    break;
                  Keyboard_Down(wparam, KeyMod);
                  break;
            }
            break;

        case WM_KEYUP:
            switch(wparam)
            {
               case VK_CONTROL:
                  if(thePrefs.KeyConfig==3)
                   {
                    KeyMod&=~0x1000; //Control
                    Keyboard_UpdateKeyMap(0x3b, FALSE);
                    break;
                   }

                  if(thePrefs.KeyConfig==2)
                   {
                    KeyMod&=~0x0800; //Option
                    Keyboard_UpdateKeyMap(0x3a, FALSE);
                    break;
                   }

                  if(Bit(lparam,24))
                  {
                    //Right Control
                    if(thePrefs.KeyConfig==1)
                     {KeyMod&=~0x0800; //Option
                      Keyboard_UpdateKeyMap(0x3a, FALSE);}
                  }
                  else
                  {
                    //Left Control
                    if(thePrefs.KeyConfig==1)
                     {KeyMod&=~0x0100; //Command
                      Keyboard_UpdateKeyMap(0x37, FALSE);}
                  }

                  break;

               case VK_SHIFT:
                  KeyMod&=~0x0200;
                  Keyboard_UpdateKeyMap(0x38, FALSE);
                  break;

               case VK_CAPITAL:
                  KeyMod&=~0x0400;
                  Keyboard_UpdateKeyMap(0x39, FALSE);
                  break;

               default:
                  KeyDown=0;
                  wparam=Win32KeyRemap(wparam, KeyMod);
                  if(wparam==0)
                    break;
                  Keyboard_Up(wparam, KeyMod);
                  break;
            }
            break;

        case WM_SYSCHAR:
            break;

        case WM_CHAR:
            break;

        case WM_NOTIFY:
        {
            LPNMHDR pnmh=(LPNMHDR) lparam;
            LPTOOLTIPTEXT lpttt=(LPTOOLTIPTEXT)pnmh;

            if(pnmh->code!=TTN_NEEDTEXT)
                return 1;

            lpttt->hinst=AppInstance;

            switch(pnmh->idFrom)
            {
                case ID_FILE_INSERTDISK1:
                    lpttt->lpszText=MAKEINTRESOURCE(IDS_TH_DISK1); break;
                case ID_FILE_INSERTDISK2:
                    lpttt->lpszText=MAKEINTRESOURCE(IDS_TH_DISK2); break;
                case ID_FILE_INSERTFLOPPY:
                    lpttt->lpszText=MAKEINTRESOURCE(IDS_TH_FLOPPY); break;
                case ID_CONTROL_RESET:
                    lpttt->lpszText=MAKEINTRESOURCE(IDS_TH_RESET); break;
                case ID_CONTROL_INTERRUPT:
                    lpttt->lpszText=MAKEINTRESOURCE(IDS_TH_INTERRUPT); break;
                case ID_CONTROL_PAUSE:
                    lpttt->lpszText=MAKEINTRESOURCE(IDS_TH_PAUSE); break;
                case ID_HELP_ABOUT:
                    lpttt->lpszText=MAKEINTRESOURCE(IDS_TH_ABOUT); break;

                default:
                    lpttt->lpszText=MAKEINTRESOURCE(IDS_TH_INVALID); break;
            }

            return(0);
        }

        case WM_CREATE:
        {
            if(hwndSplash)
                DestroyWindow(hwndSplash);

            if(thePrefs.DX)
            {
              RECT rcCursor;

              if (!DX_Init(MainWnd, 640,480,8))
              {
                thePrefs.DX=0;
                StopEmulation=1;
                PostQuitMessage(1);
                vMac_Message ("Couldn't use DirectX mode! vMac will now exit, when you start vMac again, it will not attempt to use DirectX mode.");
                return 1;
              }

              DX_Lock();

              SetRect(&rcCursor, WndX, WndY, WndX+512, WndY+342);
              ClipCursor(&rcCursor);
              SetCursor(NULL);

              hwndToolbar=NULL;
              hwndStatus=NULL;

              UpdateDXScreen(TRUE);

              DxHideCursor(TRUE);
              //SetCursor(NULL);

              Screen_Draw();
            }
            else
            {
               hwndStatus=CreateStatusWindow(WS_CHILD|WS_VISIBLE,
                                     "vMac - http://www.vMac.org", MainWnd, IDC_TOOLBAR);

               hwndToolbar=CreateToolbarEx(MainWnd, WS_CHILD|WS_VISIBLE|TBSTYLE_TOOLTIPS,
                       WM_USER, 7, AppInstance, IDR_TOOLBAR,
                       tbButtons, 10, 18, 18, 16, 16, sizeof(TBBUTTON));

               FORWARD_WM_SIZE(MainWnd, 0, 0, 0, SendMessage);
               SizeClient(MainWnd, 512, 342);

//               FrameTimer(hWnd);
            }

            hwndSplash=NULL;

            hFloppyThread=CreateThread(NULL, 0, FloppyThread, NULL, 0, &FloppyThreadID);
            hModemThread=CreateThread(NULL, 0, ModemThread, NULL, 0, &ModemThreadID);
            hPrintThread=CreateThread(NULL, 0, PrintThread, NULL, 0, &PrintThreadID);

            return 1;
        }

        case WM_CLOSE:
        {
            if(thePrefs.DX)
            {  thePrefs.DX=0;
               DX_Unlock();
               DX_End();
            }

           PostQuitMessage(1);
           vMacWin32Quit();
           StopEmulation=1;
           return 0;
        }

        case WM_ACTIVATEAPP:
            if(!thePrefs.DX)
                return 0;

            if(wparam)
            {
                RECT rcCursor;
                SetRect(&rcCursor, WndX, WndY, WndX+512, WndY+342);
                ClipCursor(&rcCursor);

                DxHideCursor(TRUE);
                //SetCursor(NULL);
            }
            else
                ClipCursor(NULL);

            return 0;

        case WM_SETCURSOR:
           if(thePrefs.DX)
           {
              DxHideCursor(TRUE);
              //SetCursor(NULL);
           }

           return 0;

        case WM_COMMAND:
            if(DXMenu==TRUE)
            {
                ClipMouse=1;
                MouseClip(ClipMouse);

                bPaused=FALSE;
                UpdateDXScreen(TRUE);
                DXMenu=FALSE;
                DX_CleanBuffers();
            }

            switch(LOWORD(wparam))
            {
                case ID_FILE_INSERTDISK1:
                    if(thePrefs.DX)
                        UpdateDXScreen(FALSE);

                    ClipCursor(NULL);

                    InsertDSK1();

                    MouseClip(0);

                    if(thePrefs.DX)
                    {
                        UpdateDXScreen(TRUE);
                        DX_CleanBuffers();
                    }

                    break;

                case ID_FILE_INSERTDISK2:
                {
                    if(thePrefs.DX)
                        UpdateDXScreen(FALSE);

                    ClipCursor(NULL);

                    InsertDSK2();

                    MouseClip(0);

                    if(thePrefs.DX)
                    {
                        UpdateDXScreen(TRUE);
                        DX_CleanBuffers();
                    }

                    break;
                }

                case ID_FILE_DISKCD:
                    //Insert a 1.4MB Mac floppy and/or Mac CD-ROM
                    Sony_Insert(1, NULL);
                    Sony_Insert(4, NULL);
                    break;

                case ID_FILE_QUIT:
                    StopEmulation=1;
                    DestroyWindow(MainWnd);
                    PostQuitMessage(1);
                    break;

                case ID_CONTROL_RESET:
                    SuspendThread(hThread_CPU);

                    if(thePrefs.DX)
                        UpdateDXScreen(FALSE);

                    ClipCursor(NULL);

                    if(IDYES==MessageBox(MainWnd,"Restarting this way may cause data loss!\nYou should restart by going to Special - Restart\n\nDo you still want to restart this way?","Reset?",MB_APPLMODAL|MB_YESNO))
                        Mac_Reset=1;

                    MouseClip(0);

                    if(thePrefs.DX)
                    {
                        UpdateDXScreen(TRUE);
                        DX_CleanBuffers();
                    }

                    ResumeThread(hThread_CPU);
                    break;

                case ID_CONTROL_PAUSE:
                    if(thePrefs.DX)
                        break;

                    if(bPaused)
                    {
                       bPaused=0;
                       ResumeThread(hThread_CPU);
            //           FrameTimer(MainWnd);
                       SendMessage(hwndStatus, SB_SETTEXT, 5, (LPARAM) "");
                    }
                    else
                    {
                       bPaused=1;
                       SuspendThread(hThread_CPU);
                       SendMessage(hwndStatus, SB_SETTEXT, 5, (LPARAM) "Paused");
                    }

                    UpdateWindow(hwndStatus);

                    break;

                case ID_CONTROL_INTERRUPT:
                    Mac_Interrupt=1;
                    break;

                case ID_OPTIONS_VIDEO:
                    SuspendThread(hThread_CPU);
                    if(Dialog_Video(MainWnd, &ScreenFPS))
                    {
                        timeKillEvent(DrawScreenID);
                        DrawScreenID=timeSetEvent(1000/ScreenFPS, 10, DrawScreen, 0, TIME_PERIODIC);
                    }
                    ResumeThread(hThread_CPU);
                    break;

                case ID_OPTIONS_AUDIO:
                {
                    SuspendThread(hThread_CPU);
                    if(Dialog_Audio(MainWnd, &thePrefs.Sound))
                    {
                       // Do we want sound?  Is sound currently off?
                       if(thePrefs.Sound && !g_bSound)
                          WaveInit();

                       // Do we not want sound and is sound on?
                       if(!thePrefs.Sound && g_bSound)
                          WaveClose();

                       if(g_bSound)
                       {
                           if(Sound_22kHz)
                               SendMessage(hwndStatus, SB_SETTEXT, 2, (LPARAM) "Sound: 22");
                           else
                               SendMessage(hwndStatus, SB_SETTEXT, 2, (LPARAM) "Sound: 11");
                       }
                       else
                          SendMessage(hwndStatus, SB_SETTEXT, 2, (LPARAM) "Sound: OFF");
                    }
                    ResumeThread(hThread_CPU);
                    break;
                }

                case ID_HELP_CONTENTS:
                    ShellExecute(NULL,"open","winhlp32.exe","vMac.hlp",NULL,SW_SHOWNORMAL);
                    break;

                case ID_HELP_ABOUT:
                    SuspendThread(hThread_CPU);
                    SetSplashTime(5000);
                    hwndSplash=CreateWindow_Splash(MainWnd);
                    UpdateWindow(hwndSplash);
                    Sleep(5000);
                    DestroyWindow(hwndSplash);
                    ResumeThread(hThread_CPU);
                    break;

                case ID_FILE_DIRECTX:
                    if(!thePrefs.DX)
                    {
                       thePrefs.DX=1;
                       CreateMainWindow();
                    }
                    else
                    {
                       thePrefs.DX=0;
                       DX_Unlock();
                       DX_End();
                       CreateMainWindow();
                       MouseClip(0);
                    }

                    break;
            }
            break;

        case WM_RBUTTONDOWN:
            if(thePrefs.DX==0)
            {
             if(ClipMouse==1)
                ClipMouse=0;
             else
                ClipMouse=1;
             MouseClip(ClipMouse);
            }
            else
            {
                ClipMouse=0;
                MouseClip(ClipMouse);

                DXMenu=TRUE;
                bPaused=TRUE;
                UpdateDXScreen(FALSE);
                TrackPopupMenu(LoadMenu(AppInstance, MAKEINTRESOURCE(IDR_DXMENU)), 0, LOWORD(lparam), HIWORD(lparam), 0, MainWnd, NULL);
            }

            break;

        case WM_DEVICECHANGE:
            switch(wparam)
            {
                case DBT_DEVICEQUERYREMOVE:
                {
                      if(Sony_Disk_Inserted(4)==1 && UseCD==1)
                         //Deny all requests to eject the CD until the MacOS ejects it
                         return BROADCAST_QUERY_DENY;

                      break;
                }


                case DBT_DEVICEREMOVECOMPLETE:
                {
                      if(Sony_Disk_Inserted(4)==1 && UseCD==1)
                        {//Don't let user eject the CD until the MacOS ejects it
                         if(thePrefs.EjectCD)
                            eject_media((CDdrive+'A'), 1);

                         vMac_Message("WARNING: do NOT remove the CD from the drive, it hasn't been properly ejected!");
                        }
                      break;
                }

                case DBT_DEVICEARRIVAL:
                    if(UseCD==1)
                        Sony_Insert(4, NULL); //Insert the CD

                    break;
        }

        case WM_ERASEBKGND:
            UpdateWindow(MainWnd);
            Screen_Refresh();
            return 1;

        case WM_MOVE:
            if(thePrefs.DX)
                break;

            WndX=(LONG) LOWORD(lparam);
            WndY=(LONG) HIWORD(lparam);
            break;

        case WM_SIZE:
          {
           RECT rcTemp;
           int  iParts[6];
           char cBuffer[20];

           if(thePrefs.DX)
           {
            if(wparam==SIZE_MINIMIZED)
            {
                //Switch to windowed mode
                thePrefs.DX=0;
                DX_Unlock();
                DX_End();
                CreateMainWindow();
            }

            break;
           }

           SendMessage(hwndToolbar,WM_SIZE,wparam,lparam);
           SendMessage(hwndStatus,WM_SIZE,wparam,lparam);

           GetClientRect(MainWnd, &g_rcClient);

           GetWindowRect(hwndToolbar, &rcTemp);
           g_rcClient.top+=rcTemp.bottom-rcTemp.top;

           GetWindowRect(hwndStatus, &rcTemp);
           g_rcClient.bottom-=rcTemp.bottom-rcTemp.top;

           // Status Window Parts
           iParts[5]=g_rcClient.right;
           iParts[4]=iParts[5]-65;
           iParts[3]=iParts[4]-55;
           iParts[2]=iParts[3]-85;
           iParts[1]=iParts[2]-70;
           iParts[0]=iParts[1]-65;

           SendMessage(hwndStatus, SB_SETPARTS, 6, (LPARAM)iParts);

           wsprintf(cBuffer, "RAM: %d MB", thePrefs.RAMSize);
           SendMessage(hwndStatus, SB_SETTEXT, 1, (LPARAM) cBuffer);

           if(g_bSound)
           {
               if(Sound_22kHz)
                   SendMessage(hwndStatus, SB_SETTEXT, 2, (LPARAM) "Sound: 22");
               else
                   SendMessage(hwndStatus, SB_SETTEXT, 2, (LPARAM) "Sound: 11");
           }
           else
              SendMessage(hwndStatus, SB_SETTEXT, 2, (LPARAM) "Sound: OFF");

           UpdateWindow(MainWnd);

           break;
          }

        case WM_DESTROY:
            StopEmulation=1;
            break;

        case WM_QUIT:
            StopEmulation=1;
            vMacWin32Quit();
            break;

        default:
            return DefWindowProc(MainWnd, uMessage, wparam, lparam);
    }
    return 0;
}

void CALLBACK WaveCallback(HWAVEOUT hwo, UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2)
{
    if(uMsg==WOM_DONE)
        iSound_BuffersAvailable++;// Start writing to the next buffer!

    return;
}

void Wave_Write(BYTE *byBuffer, BOOL bSilent, int iSlot)
{
   BYTE *pbyData;
   int i;

   if(Sound_22kHz)
   {
       pbyData=whdr[iSound_Buffer].lpData+iSlot*370;

       if(bSilent)
          for(i=0;i<370;i++)
            pbyData[i]=128;
       else
          for(i=0;i<370;i++)
            pbyData[i]=byBuffer[i*2];
   }
   else
   {
       pbyData=whdr[iSound_Buffer].lpData+iSlot*185;

       if(bSilent)
          for(i=0;i<185;i++)
            pbyData[i]=128;
       else
          for(i=0;i<185;i++)
            pbyData[i]=byBuffer[i*4];
   }

   return;
}

void Wave_Play()
{
   --iSound_BuffersAvailable;
   waveOutWrite(hWaveOut, &whdr[iSound_Buffer], sizeof(WAVEHDR));
   iSound_Buffer=(iSound_Buffer+1)%ciSound_Buffers;
   return;
}

void WaveInit()
{
   WAVEFORMATEX wfex;
   MMRESULT mmr;
   int i,j;

   Sound_22kHz=TRUE;

   wfex.wFormatTag=WAVE_FORMAT_PCM;
   wfex.nChannels=1;
   wfex.nSamplesPerSec=22050;
   wfex.nAvgBytesPerSec=22050;
   wfex.nBlockAlign=1;
   wfex.wBitsPerSample=8;
   wfex.cbSize=0;

   if(thePrefs.Sound)
   {
       mmr=waveOutOpen(&hWaveOut, WAVE_MAPPER, &wfex, (DWORD)WaveCallback, (unsigned long) AppInstance,
                   CALLBACK_FUNCTION);

       //Try 11.025 kHz if 22.05 kHz is unavailable
       if(mmr==WAVERR_BADFORMAT)
       {
           Sound_22kHz=FALSE;

           wfex.nSamplesPerSec=11025;
           wfex.nAvgBytesPerSec=11025;

           mmr=waveOutOpen(&hWaveOut, WAVE_MAPPER, &wfex, (DWORD)WaveCallback, (unsigned long) AppInstance,
                   CALLBACK_FUNCTION);
       }
   }

   for(i=0;i<ciSound_Buffers;i++)
   {
      if(Sound_22kHz)
      {
          whdr[i].lpData=(LPSTR)calloc(370*10, 1);
          whdr[i].dwBufferLength=370*10;
      }
      else
      {
          whdr[i].lpData=(LPSTR)calloc(185*10, 1);
          whdr[i].dwBufferLength=185*10;
      }

      whdr[i].dwBytesRecorded=0;
      whdr[i].dwUser=0;
      whdr[i].dwFlags=0;
      whdr[i].dwLoops=0;
      waveOutPrepareHeader(hWaveOut, &whdr[i], sizeof(WAVEHDR));
   }

   iSound_BuffersAvailable=ciSound_Buffers-1;

   if(!thePrefs.Sound || mmr!=MMSYSERR_NOERROR)
   {
      g_bSound=FALSE;
      SendMessage(hwndStatus, SB_SETTEXT, 2, (LPARAM) "Sound: OFF");
      return;
   }

   g_bSound=TRUE;

   if(Sound_22kHz)
       SendMessage(hwndStatus, SB_SETTEXT, 2, (LPARAM) "Sound: 22");
   else
       SendMessage(hwndStatus, SB_SETTEXT, 2, (LPARAM) "Sound: 11");

   return;
}

static void WaveClose()
{
   int i;

   assert(g_bSound==TRUE);

   g_bSound=FALSE;

   // Wait until all sound buffers are done playing
   //
   while(iSound_BuffersAvailable<ciSound_Buffers-1)
      Sleep(50);

   iSoundCounts=0;

   for(i=0;i<ciSound_Buffers;i++)
   {  waveOutUnprepareHeader(hWaveOut, &whdr[i], sizeof(WAVEHDR));
      free(whdr[i].lpData);
   }


   waveOutClose(hWaveOut);
}

void MouseClip(int Setting)
{
    if (ClipMouse==1)
        Setting=1;

    if(Setting==1)
    {
        RECT rcCursor;

        SetRect(&rcCursor, WndX, WndY, WndX+512, WndY+342);

        if(!thePrefs.DX)
        {
            SetRect(&rcCursor, WndX, WndY, WndX+512, WndY+342);
//            GetWindowRect(MainWnd, &rcCursor);
            rcCursor.top+=31;
            rcCursor.bottom+=31;
//            rcCursor.top+=YMenuSize;
        }

        ClipCursor(&rcCursor);
    }
    else
    {
        ClipCursor(NULL);
    }

    return;
}

BOOL Bit(ULONG TempMem, int BitNum)
{
    return((TempMem & ((ULONG)powl(2,BitNum)))!=0);
}

ULONG Win32KeyRemap(ULONG key, UWORD modifier)
{
    int Shift=modifier&0x0200;
    int Command=modifier&0x0100;
    int Option=modifier&0x0800;

    if (key>=0x41 && key<=0x5A && !Shift) //unshifted letter keys
      return(key+0x20);

    if (key==VK_SPACE)
      return(key);

    if (key>=0x41 && key<=0x5A && Shift && !Option && !Command) //shifted letter keys
      return(key);

    if (key>=0x30 && key<=0x39 && (!Shift || Option || Command)) //unshifted number keys
      return(key);

    if (key>=VK_NUMPAD0 && key<=VK_NUMPAD9) //Number pad
      return(key-0x30);

    if (key==VK_DELETE && KeyDown) //Macro for delete
    {
        PostMessage(MainWnd, WM_KEYUP,   VK_DELETE, 0);
        PostMessage(MainWnd, WM_KEYDOWN, VK_BACK, 0);
        PostMessage(MainWnd, WM_KEYUP,   VK_BACK, 0);

        return(0x1D); //Right arrow
    }

    if (key==VK_DECIMAL)
      return(0x2E);

    if (key==VK_ADD)
      return(0x2B);

    if (key==VK_SUBTRACT)
      return(0x2D);

    if (key==VK_MULTIPLY)
      return(0x2A);

    if (key==VK_DIVIDE)
      return(0x2F);

    if (key==VK_BACK)
      return(key);

    if (key==VK_RETURN)
      return(key);

    if (key==VK_TAB)
      return(key);

    if (key==VK_LEFT)
      return(0x1C);

    if (key==VK_RIGHT)
      return(0x1D);

    if (key==VK_UP)
      return(0x1E);

    if (key==VK_DOWN)
      return(0x1F);

    if (key==27) //ESC
      return(key);

    if (key==VkKeyScan('=') && !Shift)
      return(0x3D);

    if (key==VkKeyScan('=') && Shift)
      return(0x2B);

    if (key==VkKeyScan('-') && !Shift)
      return(0x2D);

    if (key==VkKeyScan('-') && Shift)
      return(0x5F);

    if (key==VkKeyScan(',') && !Shift)
      return(0x2C);

    if (key==VkKeyScan(',') && Shift)
      return(key);

    if (key==VkKeyScan('.') && !Shift)
      return(0x2E);

    if (key==VkKeyScan('.') && Shift)
      return(key);

    if (key==VkKeyScan('`') && !Shift)
      return(0x60);

    if (key==VkKeyScan('`') && Shift)
      return(0x7E);

    if (key==VkKeyScan('\'') && !Shift)
      return(0x27);

    if (key==VkKeyScan('\'') && Shift)
      return(0x22);

    if (key==VkKeyScan(';') && !Shift)
      return(0x3B);

    if (key==VkKeyScan(';') && Shift)
      return(0x3A);

    if (key==VkKeyScan('0') && Shift)
      return(0x29);

    if (key==VkKeyScan('1') && Shift)
      return(0x21);

    if (key==VkKeyScan('2') && Shift)
      return(0x40);

    if (key==VkKeyScan('3') && Shift)
      return(0x23);

    if (key==VkKeyScan('4') && Shift)
      return(0x24);

    if (key==VkKeyScan('5') && Shift)
      return(0x25);

    if (key==VkKeyScan('6') && Shift)
      return(0x5E);

    if (key==VkKeyScan('7') && Shift)
      return(0x26);

    if (key==VkKeyScan('8') && Shift)
      return(0x2A);

    if (key==VkKeyScan('9') && Shift)
      return(0x28);

    if (key==VkKeyScan('/') && !Shift)
      return(0x2F);

    if (key==VkKeyScan('/') && Shift)
      return(key);

    if (key==VkKeyScan('\\') && !Shift)
      return(key);

    if (key==VkKeyScan('\\') && Shift)
      return(0x7C);

    if (key==VkKeyScan('[') && !Shift)
      return(key);

    if (key==VkKeyScan('[') && Shift)
      return(0x7B);

    if (key==VkKeyScan(']') && !Shift)
      return(key);

    if (key==VkKeyScan(']') && Shift)
      return(0x7D);

    return(0);
}

void InsertDSK1(void)
{
    if(Sony_Disk_Inserted(2)==0)
    {
        if(Win32OpenDSK()==0)
        {
            strcpy(thePrefs.DrivePath[0],vMacOpenFile);
            Sony_Insert(2,thePrefs.DrivePath[0]);
        }
    }
    else
        vMac_Message("There is already a disk in that drive, you must eject it before you can insert another disk.");

    return;
}

void InsertDSK2(void)
{
    if(Sony_Disk_Inserted(3)==0)
    {
        if(Win32OpenDSK()==0)
        {
            strcpy(thePrefs.DrivePath[1],vMacOpenFile);
            Sony_Insert(3,thePrefs.DrivePath[1]);
        }
    }
    else
        vMac_Message("There is already a disk in that drive, you must eject it before you can insert another disk.");

    return;
}

BYTE Win32OpenDSK(void)
{
    OPENFILENAME ofn;
    char szDirName[256];
    char szFile[256], szFileTitle[256];
    UINT  i, cbString;
    char  chReplace;
    char  szFilter[256];
    HFILE hf;

    SuspendThread(hThread_CPU);

    szDirName[0]='\0';
    szFile[0]='\0';
    strcpy(szFilter,"Disk images|*.DSK;*.HF?;*.IMG;*.IMA;*.IMAGE|All files (*.*)|*.*|\0");

    cbString=strlen(szFilter);

    chReplace = szFilter[cbString - 1];

    for (i = 0; szFilter[i] != '\0'; ++i)
    {
        if (szFilter[i] == chReplace)
            szFilter[i] = '\0';
    }

    memset(&ofn, 0, sizeof(OPENFILENAME));

    ofn.lStructSize = sizeof(OPENFILENAME);
    ofn.hwndOwner = MainWnd;
    ofn.lpstrFilter = szFilter;
    ofn.nFilterIndex = 1;
    ofn.lpstrFile= szFile;
    ofn.nMaxFile = sizeof(szFile);
    ofn.lpstrFileTitle = szFileTitle;
    ofn.nMaxFileTitle = sizeof(szFileTitle);
    ofn.lpstrInitialDir = szDirName;
    ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;

    if(0!=GetOpenFileName(&ofn))
    {
        strcpy(vMacOpenFile,ofn.lpstrFile);
        ResumeThread(hThread_CPU);
        return(0);
    }
    else
    {
        vMacOpenFile[0]='\0';
        ResumeThread(hThread_CPU);
        return(1);
    }
}

BOOL Win32InitApplication(HINSTANCE hInstance)
{
    WNDCLASSEX wc;

    wc.cbSize        = sizeof(WNDCLASSEX);
    wc.style         = CS_HREDRAW|CS_VREDRAW;
    wc.lpfnWndProc   = (WNDPROC)Win32WMProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = hInstance;
    wc.hIcon         = LoadIcon(hInstance, IDI_VMAC);
    wc.hCursor       = LoadCursor(NULL,IDC_ARROW);
    wc.hbrBackground = (HBRUSH) (SS_WHITERECT);
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = WndClassName;
    wc.hIconSm       = NULL;

    if (!RegisterClassEx(&wc))
    {
        if (!RegisterClass((LPWNDCLASS)&wc.style))
           return FALSE;
    }
    return TRUE;
}

void CreateMainWindow(void)
{
    SuspendThread(hThread_CPU);

    if(hFloppyThread)
        TerminateThread(hFloppyThread, 0);
    if(hModemThread)
        TerminateThread(hModemThread,0);
    if(hPrintThread)
        TerminateThread(hPrintThread,0);
    if(ModemPort)
    {
        CloseHandle(ModemPort);
        ModemPort=0;
    }
    if(PrintPort)
    {
        CloseHandle(PrintPort);
        PrintPort=0;
    }


    if(MainWnd)
    {
        MSG msg;

        DestroyWindow(MainWnd);

        while (!StopEmulation)
        {
            GetMessage(&msg,NULL,0,0);
            Win32WMProc(msg.hwnd, msg.message, msg.wParam, msg.lParam);
        }

        StopEmulation=0;
    }

    if(thePrefs.DX)
    {
        WndX=((640-512)/2) & ~7;
        WndY=(480-342)/2;

        MainWnd = CreateWindow(WndClassName, WndTitle, WS_VISIBLE|WS_POPUP|WS_SYSMENU, WndX, WndY,/*0, 0,*/
                    GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN),
                    NULL, NULL, AppInstance, NULL);

        if (!MainWnd)
        {
            vMac_Message("ERROR! Couldn't create vMac DirectX window!");
            thePrefs.DX=0;
            StopEmulation=1;
            ResumeThread(hThread_CPU);
            PostQuitMessage(0);
            return;
        }

        SendMessage(MainWnd, WM_ACTIVATEAPP, 1, 0);
    }
    else
    {
        DWORD dwStyle;
        PHKEY RegKey;
        int Temp=4;
        int XSize=512+(XBorder*2);
        int YSize=342+(YBorder*2)+YMenuSize+YMenu+31;

        WndX=(ScreenX-XSize)/2;
        WndY=(ScreenY-YSize)/2;

        //Get WndX and WndY from registry
        RegOpenKeyEx(HKEY_LOCAL_MACHINE,"SOFTWARE\\vMac\0", 0, KEY_QUERY_VALUE, &RegKey);
        RegQueryValueEx(RegKey,"WndX\0",NULL,NULL,&WndX,&Temp);
        RegQueryValueEx(RegKey,"WndY\0",NULL,NULL,&WndY,&Temp);
        RegCloseKey(RegKey);

        if (WndX<0)
            WndX=0;

        if (WndY<0)
            WndY=0;

        dwStyle=WS_VISIBLE|WS_SYSMENU|WS_MINIMIZEBOX;

        MainWnd = CreateWindow(WndClassName, WndTitle,
            dwStyle, WndX, WndY, XSize, YSize, NULL,
            LoadMenu(AppInstance, MAKEINTRESOURCE(IDR_MAINMENU)),
            AppInstance, NULL);

        if (!MainWnd)
        {
            StopEmulation=1;
            ResumeThread(hThread_CPU);
            return;
        }

        if(!DrawScreenID)
            DrawScreenID=timeSetEvent(1000/ScreenFPS, 10, DrawScreen, 0, TIME_PERIODIC);

        if(!uTimeID_60th)
            uTimeID_60th=timeSetEvent(1000/60, 0, TimeProc_60, 0, TIME_PERIODIC);

        ShowWindow(MainWnd, CmdShow);
        UpdateWindow(MainWnd);

    }

    MainWndDC=GetWindowDC(MainWnd);

    StopEmulation=0;

    KillTimer(MainWnd,1);
    SetTimer(MainWnd,1,1000,NULL);

    ResumeThread(hThread_CPU);

    //Floppy, Modem, and Print threads are created in WM_CREATE

    return;
}

BOOL Win32InitInstance(HINSTANCE hInstance, LONG nCmdShow)
{
   SetSplashTime(2000);
   hwndSplash=CreateWindow_Splash(MainWnd);
   UpdateWindow(hwndSplash);
   Sleep(2000);

   WaveInit();
   return TRUE;
}

void vMac_Beep(void)
{
    MessageBeep(MB_OK);
    return;
}

void vMac_Message(char * Message)
{
#ifdef _Win32_Debug
    fputs(Message,DebugFile);
    fputc('\n',DebugFile);
    fflush(DebugFile);
#else
    if(thePrefs.DX)
        UpdateDXScreen(FALSE);

    ClipCursor(NULL);

    if(!bPaused)
        SuspendThread(hThread_CPU);

    MessageBox(MainWnd,Message,"vMac",MB_APPLMODAL|MB_OK);

    if(!bPaused)
        ResumeThread(hThread_CPU);

    MouseClip(0);

    if(thePrefs.DX)
    {
        UpdateDXScreen(TRUE);
        DX_CleanBuffers();
    }
#endif
    return;
}

//1.4MB Mac floppy reading/writing code for Win32
//Written by Lauri Pesonen

// #include "afx.h"
// #include "stdafx.h"
#include <winioctl.h>

//extern "C" {

static int m_silent = 0;

// To be strict, this should be the sector size...
#define ALIGN_MEMORY_SIZE 512

// Record floppy characteristics. These
// do not change during session.
typedef struct {
	int m_C0;
	int m_H0;
	int m_S0;
	int m_H0_S0;
	int m_sector_size;
	int is_inited;
	cachetype fl_cache;
} floppytype;
static floppytype fpar[MAX_FLOPPIES];

char *sector_buffer = 0;

// Low level routines:
// count must be full sectors everywhere
// & base addresses must be aligned to sector boundaries.

// VER_PLATFORM_WIN32_WINDOWS, VER_PLATFORM_WIN32_NT
#define VER_UNDEFINED 123456
static DWORD win_os = VER_UNDEFINED;

// common for both platforms
// static HANDLE hfloppy = 0;

// LBA = (C1 * H0 + H1) * S0 + S1 - 1
// 1.44 floppy: C,H,S = 80,2,18

// Win95 vxd shit
#define VWIN32_DIOC_DOS_IOCTL		1
#define VWIN32_DIOC_DOS_INT25		2
#define VWIN32_DIOC_DOS_INT26		3
#define VWIN32_DIOC_DOS_INT13		4
#define VWIN32_DIOC_DOS_DRIVEINFO	6

/*
VWIN32_DIOC_DOS_DRIVEINFO (6) 	Performs Interrupt 21h Function 730X commands. This value is supported in Windows 95 OEM Service Release 2 and later.
VWIN32_DIOC_DOS_INT13 (4) 	Performs Interrupt 13h commands
VWIN32_DIOC_DOS_INT25 (2) 	Performs the Absolute Disk Read command (Interrupt 25h)
VWIN32_DIOC_DOS_INT26 (3) 	Performs the Absolute Disk Write command (Interrupt 25h)
VWIN32_DIOC_DOS_IOCTL (1) 	Performs the specified MS-DOS device I/O control function (Interrupt 21h Function 4400h through 4411h)
*/

typedef struct _DIOC_REGISTERS {
    DWORD reg_EBX;
    DWORD reg_EDX;
    DWORD reg_ECX;
    DWORD reg_EAX;
    DWORD reg_EDI;
    DWORD reg_ESI;
    DWORD reg_Flags;
} DIOC_REGISTERS, *PDIOC_REGISTERS;

void record_geometry( int drive, int C, int H, int S, int sector_size )
{
	fpar[drive].m_C0 = C;
	fpar[drive].m_H0 = H;
	fpar[drive].m_S0 = S;
	fpar[drive].m_H0_S0 = H * S;
	fpar[drive].m_sector_size = sector_size;
}

void floppy_get_geometry(
	int drive,
	int *pC, int *pH, int *pS, int *psector_size
)
{
	*pC = fpar[drive].m_C0;
	*pH = fpar[drive].m_H0;
	*pS = fpar[drive].m_S0;
	*psector_size = fpar[drive].m_sector_size;
}

HANDLE w95_floppy_init( void )
{
	HANDLE hfloppy = 0;

	hfloppy = CreateFile("\\\\.\\vwin32",
    GENERIC_READ,
    FILE_SHARE_READ | FILE_SHARE_WRITE,
		NULL,
    OPEN_EXISTING,
    FILE_FLAG_DELETE_ON_CLOSE,
    NULL
	);
	if( hfloppy == INVALID_HANDLE_VALUE ) {
		hfloppy = 0;
	}
	return(hfloppy);
}

int w95_reset_controller( HANDLE hfloppy, int drive )
{
	DIOC_REGISTERS reg;
	BOOL fResult = 0;
	DWORD cb;

	if(!hfloppy) return(0);

	reg.reg_EAX = 0;
	reg.reg_EDX = drive;
	reg.reg_Flags = 0x0001;

	fResult = DeviceIoControl(
		hfloppy,
		VWIN32_DIOC_DOS_INT13,
		&reg, sizeof(reg),
		&reg, sizeof(reg),
		&cb, 0);
	if(!fResult || (reg.reg_Flags & 1)) {
//                if(!m_silent&&thePrefs.Floppy!=2) vMac_Message( "Cannot reset floppy controller" );
		fResult = 0;
	}
	return( fResult );
}

int w95_floppy_read( HANDLE hfloppy, int drive, int LBA, int count, char *buf )
{
	DIOC_REGISTERS reg;
	BOOL fResult = 0;
	DWORD cb;
	int i, sect_count, sectors_read, C, H, S;
	int H0, S0, H0S0;

	H0 = fpar[drive].m_H0;
	S0 = fpar[drive].m_S0,
	H0S0 = H0 * S0;

	if(!hfloppy) return(0);

	sect_count = count / fpar[drive].m_sector_size;

	LBA /= fpar[drive].m_sector_size;

	C = LBA / H0S0;
	H = (LBA - C * H0S0) / S0;
	S = (LBA - (C * H0 + H) * S0) + 1;

	for( i=0; i<3; i++ ) {
                reg.reg_EAX = 0x0200 | (sect_count & 0x7F); // max 128
		reg.reg_EBX = (DWORD)buf;
		reg.reg_ECX = (S & 0x3F) |
									( (C & 0xFF) << 8) |
									( ((C >> 8) & 0x3) << 6 );
		reg.reg_EDX = drive | (H << 8);
		reg.reg_Flags = 0x0001;

		fResult = DeviceIoControl(
			hfloppy,
			VWIN32_DIOC_DOS_INT13,
			&reg, sizeof(reg),
			&reg, sizeof(reg),
			&cb, 0);

		sectors_read = (reg.reg_EAX & 0xFF);

		if(!fResult || (reg.reg_Flags & 1) || sectors_read != sect_count) {
			fResult = FALSE;
			w95_reset_controller( hfloppy, drive );
		} else {
			break;
		}
	}
	if(fResult) {
		return( sectors_read * fpar[drive].m_sector_size );
	} else {
		return( 0 );
	}
}

int w95_floppy_write( HANDLE hfloppy, int drive, int LBA, int count, char *buf )
{
	DIOC_REGISTERS reg;
	BOOL fResult = 0;
	DWORD cb;
	int sect_count, sectors_written, C, H, S;
	int H0, S0, H0S0;

	H0 = fpar[drive].m_H0;
	S0 = fpar[drive].m_S0,
	H0S0 = H0 * S0;

	if(!hfloppy) return(0);

	sect_count = count / fpar[drive].m_sector_size;

	LBA /= fpar[drive].m_sector_size;

	C = LBA / H0S0;
	H = (LBA - C * H0S0) / S0;
	S = (LBA - (C * H0 + H) * S0) + 1;

	reg.reg_EAX = 0x0300 | (sect_count & 0x7F); // max 128
	reg.reg_EBX = (DWORD)buf;
	reg.reg_ECX = (S & 0x3F) |
								( (C & 0xFF) << 8) |
								( ((C >> 8) & 0x3) << 6 );
	reg.reg_EDX = drive | (H << 8);
	reg.reg_Flags = 0x0001;

	fResult = DeviceIoControl(
		hfloppy,
		VWIN32_DIOC_DOS_INT13,
		&reg, sizeof(reg),
		&reg, sizeof(reg),
		&cb, 0);

	sectors_written = (reg.reg_EAX & 0xFF);

	if(!fResult || (reg.reg_Flags & 1) || sectors_written != sect_count) {
		w95_reset_controller( hfloppy, drive );
		fResult = FALSE;
	}

	if(fResult) {
		return( sectors_written * fpar[drive].m_sector_size );
	} else {
		return( 0 );
	}
}

HANDLE nt_floppy_init( int drive )
{
	char dnamebuf[64];
	char dname[64];
	char dnamel[64];
	int rc;
	HANDLE hfloppy = 0;

	sprintf(dname,"HfvDsk_%c",(char)('A' + drive));
	sprintf(dnamel,"\\Device\\Floppy%d",drive);

	if ( QueryDosDevice(dname, dnamebuf, sizeof(dnamebuf)) == 0) {
		rc = GetLastError();
		if ( rc == ERROR_FILE_NOT_FOUND ) {
			if ( DefineDosDevice(DDD_RAW_TARGET_PATH, dname, dnamel) == 0 ) {
				return( 0);
			}
		} else {
			return(0);
		}
	}
	sprintf(dnamebuf,"\\\\.\\%s", dname);
	hfloppy = CreateFile(
		dnamebuf,
		GENERIC_READ | GENERIC_WRITE,
		FILE_SHARE_READ,
		/* | FILE_SHARE_WRITE */
		NULL,
		OPEN_EXISTING,
		FILE_FLAG_RANDOM_ACCESS, // | FILE_FLAG_NO_BUFFERING | FILE_FLAG_RANDOM_ACCESS
		NULL
	);
	if( hfloppy == INVALID_HANDLE_VALUE ) {
		hfloppy = 0;
	}
	return(hfloppy);
}

int nt_floppy_read( HANDLE hfloppy, int LBA, int count, char *buf )
{
	DWORD bytes_read;
	OVERLAPPED overl;
	char *aux_buffer = 0;
	char *rd_buffer;

	if(!hfloppy) return(0);

	if(count == 0) return(0);

	// If not aligned to sector boundary -> must use another buffer
	if( (unsigned long)buf & (ALIGN_MEMORY_SIZE-1) ) {
		aux_buffer = (char *)VirtualAlloc(
				NULL, count, MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE );
		if(!aux_buffer) return(0);
		rd_buffer = aux_buffer;
	} else {
		rd_buffer = buf;
	}

	overl.Offset = LBA;
	overl.OffsetHigh = 0;
	overl.hEvent = NULL;

  if (ReadFile (hfloppy, rd_buffer, count, &bytes_read, &overl) &&
			(int)bytes_read == count)
	{
		;
	} else {
		bytes_read = 0;
		return(0);
	}
	if(aux_buffer) {
		memcpy( buf, rd_buffer, count );
		VirtualFree( aux_buffer, 0, MEM_RELEASE  );
	}
	return(bytes_read);
}

int nt_floppy_write( HANDLE hfloppy, int LBA, int count, char *buf )
{
	DWORD bytes_written;
	OVERLAPPED overl;
	char *aux_buffer = 0;

	if(!hfloppy) return(0);
	if(count == 0) return(0);

	overl.Offset = LBA;
	overl.OffsetHigh = 0;
	overl.hEvent = NULL;

	// If not aligned to sector boundary -> must use another buffer
	if( (unsigned long)buf & (ALIGN_MEMORY_SIZE-1) ) {
		aux_buffer = (char *)VirtualAlloc(
				NULL, count, MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE );
		if(!aux_buffer) return(0);
		memcpy( aux_buffer, buf, count );
		buf = aux_buffer;
	}

  if (WriteFile (hfloppy, buf, count, &bytes_written, &overl) &&
			(int)bytes_written == count)
	{
		;
	} else {
		bytes_written = 0;
	}
	if(aux_buffer) VirtualFree( aux_buffer, 0, MEM_RELEASE  );
	return(bytes_written);
}

void init_os( void )
{
	OSVERSIONINFO osv;

	if(win_os != VER_UNDEFINED) return;

	win_os = VER_PLATFORM_WIN32_WINDOWS;
	osv.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	if(GetVersionEx( &osv )) {
		if(osv.dwPlatformId == VER_PLATFORM_WIN32s) {
//                        vMac_Message( "Cannot run on Win32s" );
		} else {
			win_os = osv.dwPlatformId;
		}
	}
}

HANDLE xt_floppy_init( int drive )
{
	if(win_os == VER_PLATFORM_WIN32_NT) {
		return(nt_floppy_init(drive));
	} else {
		return(w95_floppy_init());
	}
}

int w95_get_floppy_geometry(
	HANDLE hfloppy,
	int drive
)
{
	DWORD cb;
	BOOL fResult = 0;
	DIOC_REGISTERS reg;
	char *disk_base_table;
	int C, H, S, sector_size;

	if(!hfloppy) return(0);

	reg.reg_EAX = 0x0800;
	reg.reg_EDX = drive;
	reg.reg_Flags = 0x0001;

	fResult = DeviceIoControl(
		hfloppy,
		VWIN32_DIOC_DOS_INT13,
		&reg, sizeof(reg),
		&reg, sizeof(reg),
		&cb, 0);

	// Clearer this way...
	C = ((reg.reg_ECX >> 8) & 0xFF) |
	 	  (((reg.reg_ECX >> 6) & 0x3) << 8);
	H = (reg.reg_EDX >> 8) & 0xFF;
	S = reg.reg_ECX & 0x3F;

	// convert from max values to counts
	C++;
	H++;
	// S is ok (1-based)

	sector_size = 512;
	disk_base_table = (char *)reg.reg_EDI;
	if(disk_base_table && !IsBadReadPtr(disk_base_table,11)) {
		int bps_code = (int)disk_base_table[3];
		// sanity check
		if(bps_code >= 0 && bps_code <= 5) {
			sector_size = (128 << bps_code);
		}
	}

	if(!fResult || (reg.reg_Flags & 1)) {
		fResult = FALSE;
		w95_reset_controller( hfloppy, drive );
		record_geometry( drive, 80, 2, 18, 512 );
	} else {
	  record_geometry( drive, C, H, S, sector_size );
	}
	return(fResult);
}

int nt_get_floppy_geometry(
	HANDLE hfloppy,
	int drive
)
{
	DISK_GEOMETRY geom;
	DWORD cb;
	BOOL fResult = 0;

	if(!hfloppy) return(0);

	fResult = DeviceIoControl(
		hfloppy,
		IOCTL_DISK_GET_DRIVE_GEOMETRY,
		NULL, 0,
		&geom, sizeof(DISK_GEOMETRY),
		&cb, 0);
	if(fResult) {
		record_geometry(
			drive,
			geom.Cylinders.u.LowPart,
			geom.TracksPerCylinder,
			geom.SectorsPerTrack,
			geom.BytesPerSector
		);
	} else {
		record_geometry( drive, 80, 2, 18, 512 );
	}
	return(fResult);
}

int get_floppy_geometry(
	HANDLE hfloppy,
	int drive
)
{
	int ok;

	if(fpar[drive].is_inited) return(1);

	if(!hfloppy) return(0);
	if(win_os == VER_PLATFORM_WIN32_NT) {
		ok = nt_get_floppy_geometry(hfloppy,drive);
		if(ok) fpar[drive].is_inited = 1;
		return(ok);
	} else {
		ok = w95_get_floppy_geometry(hfloppy,drive);
		if(ok) fpar[drive].is_inited = 1;
		return(ok);
	}
}

static HANDLE fl_handle[MAX_FLOPPIES];
static long fl_seekpoint[MAX_FLOPPIES];
static int fl_refcount[MAX_FLOPPIES];

#define MY_FLOPPY_HANDLE_A 0xBADBABE

#define IS_OUR_FLOPPY(h) ((h) >= MY_FLOPPY_HANDLE_A && (h) < MY_FLOPPY_HANDLE_A+MAX_FLOPPIES)
#define GETDRINX(h) ((h)-MY_FLOPPY_HANDLE_A)

void w95_floppy_final( HANDLE hfloppy )
{
	if(hfloppy) {
		CloseHandle(hfloppy);
	}
}

void nt_floppy_final( HANDLE hfloppy )
{
	if(hfloppy) {
		CloseHandle(hfloppy);
	}
}

void floppy_do_final( int drive )
{
	if(win_os == VER_PLATFORM_WIN32_NT) {
		nt_floppy_final(fl_handle[drive]);
	} else {
		w95_floppy_final(fl_handle[drive]);
	}
	cache_clear( &fpar[drive].fl_cache );
}

void floppy_final( int drive )
{
	if(!fl_handle[drive]) return;

	if(--fl_refcount[drive] > 0) return;
	fl_refcount[drive] = 0; // superfluous
	floppy_do_final(drive);
	fl_handle[drive] = 0;
}

HANDLE floppy_init( int drive, BOOL check_geometry )
{
	HANDLE hFloppy = 0;
	BOOL fResult;

//   DX_GDI();

	if(fl_handle[drive]) {
		fl_refcount[drive]++;
		return(fl_handle[drive]);
	}
	hFloppy = xt_floppy_init(drive);
	if(hFloppy) {
		fl_handle[drive] = hFloppy;
		fl_refcount[drive]++;
		if(check_geometry) {
			fResult = get_floppy_geometry(hFloppy,drive);
			if(!fResult) {
//                                if(!m_silent&&thePrefs.Floppy!=2) vMac_Message( "Cannot get disk geometry" );
				floppy_final(drive);
				hFloppy = 0;
			}
		}
	}

//   DX_GDIEnd();

	return(hFloppy);
}

int do_floppy_read( HANDLE hfloppy, int drive, int LBA, int count, char *buf )
{
	if(win_os == VER_PLATFORM_WIN32_NT) {
		return(nt_floppy_read( hfloppy, LBA, count, buf ));
	} else {
		return(w95_floppy_read( hfloppy, drive, LBA, count, buf ));
	}
}

int floppy_read( HANDLE hfloppy, int drive, int LBA, int count, char *buf )
{
	int l1, l2, cc, ss, got_bytes, nblocks, first_block;
	int i, c_count, s_inx;
	int ok_bytes = 0;
	cachetype *cptr = &fpar[drive].fl_cache;
	char *ptr, *ttptr, *tmpbuf;

	if(hfloppy == 0|| count <= 0) return(0);

	ss = fpar[drive].m_sector_size;
	l1 = (LBA / ss) * ss;
	l2 = ((LBA+count-1+ss)/ss) * ss;
	cc = l2-l1;
	nblocks = cc / ss;
	first_block = LBA / ss;

	ptr = buf;
	s_inx = LBA-l1;
	c_count = ss - s_inx;
	if(c_count > count) c_count = count;
	for(i=0; i<nblocks; i++) {
		if(cache_get( cptr, first_block+i, sector_buffer )) {
			memcpy( ptr, sector_buffer+s_inx, c_count );
			ok_bytes += c_count;
			ptr += c_count;
			s_inx = 0;
			c_count = ss;
			if(c_count > count-ok_bytes) c_count = count-ok_bytes;
		} else {
			break;
		}
	}

	if(i != nblocks && count != ok_bytes) {
		int bytes_left, blocks_left, alignedleft;

		bytes_left = count - ok_bytes;
		blocks_left = nblocks - i;
		alignedleft = blocks_left*ss;

		tmpbuf = (char *)VirtualAlloc(
				NULL, alignedleft,
				MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE );
		if(tmpbuf) {
			got_bytes = do_floppy_read( hfloppy, drive,
						(first_block+i)*ss, alignedleft, tmpbuf );
			if(got_bytes != alignedleft) {
				// should never happen
				VirtualFree( tmpbuf, 0, MEM_RELEASE  );
				return(ok_bytes);
			}
			ttptr = tmpbuf;
			for( ; i<nblocks; i++ ) {
				memcpy( ptr, ttptr+s_inx, c_count );
				ok_bytes += c_count;
				ptr += c_count;
				s_inx = 0;
				c_count = ss;
				if(c_count > count-ok_bytes) c_count = count-ok_bytes;
				cache_put( cptr, first_block+i, ttptr, ss );
				ttptr += ss;
			}
			VirtualFree( tmpbuf, 0, MEM_RELEASE  );
		}
	}

	return(ok_bytes);
}

int floppy_write( HANDLE hfloppy, int drive, int LBA, int count, char *buf )
{
	int l1, l2, cc, ss, nblocks, first_block;
	int i;
	int ok_bytes = 0;
	cachetype *cptr = &fpar[drive].fl_cache;
	char *ttptr;
	int bytes_written;

	if(hfloppy == 0|| count <= 0) return(0);

	if(win_os == VER_PLATFORM_WIN32_NT) {
		bytes_written = nt_floppy_write( hfloppy, LBA, count, buf );
	} else {
		bytes_written = w95_floppy_write( hfloppy, drive, LBA, count, buf );
	}

	count = bytes_written;

	ss = fpar[drive].m_sector_size;
	l1 = (LBA / ss) * ss;
	l2 = ((LBA+count-1+ss)/ss) * ss;
	cc = l2-l1;
	nblocks = cc / ss;
	first_block = LBA / ss;

	if(l1 < LBA) cache_remove( cptr, first_block-1, ss );
	if(l2 > LBA+count) cache_remove( cptr, first_block+nblocks, ss );
	ttptr = buf;
	for(i=0; i<nblocks; i++) {
		cache_put( cptr, first_block+i, ttptr, ss );
		ttptr += ss;
	}

	return(bytes_written);
}


////////////////////////////////////////////////////////////
long get_floppy_size( HANDLE hfloppy, int drive )
{
	if(hfloppy) {
		return( fpar[drive].m_C0 * fpar[drive].m_H0 *
						fpar[drive].m_S0 * fpar[drive].m_sector_size );
	} else {
		return(0);
	}
}

void floppy_module_global_init( void )
{
	int i;

	init_os();

	if(!sector_buffer) {
		sector_buffer = (char *)VirtualAlloc(
					NULL, 8192, MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE );
	}
	for(i=0; i<MAX_FLOPPIES; i++) {
		memset( &fpar[i], 0, sizeof(floppytype) );
		fl_seekpoint[i] = 0;
		fl_handle[i] = 0;
		fl_refcount[i] = 0;
		cache_init( &fpar[i].fl_cache );
	}
        //HFSIFACE_init(0);
        /*
        fhook_init_fake_funcs(
			my_open,
			my_close,
			my_read,
			my_write,
			my_lseek
	);
	fhook_set_fake_funcs();
        */
}

void floppy_module_global_final( void )
{
	int i;

	if(sector_buffer) {
		VirtualFree( sector_buffer, 0, MEM_RELEASE  );
		sector_buffer = 0;
	}
	for(i=0; i<MAX_FLOPPIES; i++) {
		if(fl_handle[i]) {
			floppy_do_final(i);
			fl_seekpoint[i] = 0;
			fl_handle[i] = 0;
			fl_refcount[i] = 0;
		}
		cache_final( &fpar[i].fl_cache );
	}
}

int silencer( int shutup )
{
	int prev = m_silent;
	m_silent = shutup;
        //HFSIFACE_silencer( shutup );
	return(prev);
}

int is_any_floppy_present( int drive )
{
	int result = 0;
	HANDLE hFloppy;
	int prev_silence;

	prev_silence = silencer(1);
        //HFSIFACE_init(0);
	hFloppy = floppy_init( drive, FALSE );
	if(hFloppy) {
		result = 1;
		floppy_final( drive );
	}
	silencer(prev_silence);
	return(result);
}

int is_hfs_floppy_present( int drive )
{
	int result = 0;
	char volpath[100];
	HANDLE hFloppy;
	int prev_silence;

	prev_silence = silencer(1);
        //HFSIFACE_init(0);
	hFloppy = floppy_init( drive, TRUE );
	if(hFloppy) {
		floppy_final( drive );
	}
	silencer(prev_silence);
	return(result);
}

int get_floppy_max_size( int drive )
{
	int sz = 0;
	HANDLE hFloppy;

	hFloppy = floppy_init( drive, TRUE );
	if(hFloppy) {
		sz = get_floppy_size( hFloppy, drive );
		floppy_final( drive );
	}
	return(sz);
}

void clear_cache_by_drive_index( int drive )
{
	cache_clear( &fpar[drive].fl_cache );
}

//} // extern "C"

void cache_clear( cachetype *cptr )
{
	if(cptr->inited) {
		cptr->res_count = 0;
		memset( cptr->LRU, 0, NBLOCKS * sizeof(int) );
	}
}

static int init( cachetype *cptr, int sector_size )
{
	cache_clear( cptr );
	cptr->sector_size = sector_size;
	cptr->blocks = (char *)VirtualAlloc(
			NULL, NBLOCKS*sector_size,
			MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE );
	return(cptr->blocks != NULL);
}

static void final( cachetype *cptr )
{
	if(cptr->blocks) {
		VirtualFree( cptr->blocks, 0, MEM_RELEASE  );
		cptr->blocks = 0;
	}
	cptr->inited = 0;
}

void cache_init( cachetype *cptr )
{
	cptr->inited = 0;
}

void cache_final( cachetype *cptr )
{
	if(cptr->inited) {
		final( cptr );
		cptr->inited = 0;
	}
}

static int in_cache( cachetype *cptr, int block )
{
	int i;
	for(i=cptr->res_count-1; i>=0; i--) {
		if(cptr->block[i] == block) return(i);
	}
	return(-1);
}

static int get_LRU( cachetype *cptr )
{
	int i, result = 0;
	DWORD mtime = cptr->LRU[0];

	for(i=1; i<NBLOCKS; i++) {
		if(cptr->LRU[i] < mtime) {
			mtime = cptr->LRU[i];
			result = i;
		}
	}
	return(result);
}

void cache_put( cachetype *cptr, int block, char *buf, int ss )
{
	int inx;

	if(!cptr->inited) {
		if(!init(cptr,ss)) return;
		cptr->inited = 1;
	}
	inx = in_cache( cptr, block );
	if(inx < 0) {
		if(cptr->res_count == NBLOCKS) {
			inx = get_LRU( cptr );
		} else {
			inx = cptr->res_count++;
		}
		cptr->block[inx] = block;
	}
	cptr->LRU[inx] = GetTickCount();
	memcpy( cptr->blocks + inx * ss, buf, ss );
}

int cache_get( cachetype *cptr, int block, char *buf )
{
	int inx;

	if(!cptr->inited) return(0);

	inx = in_cache( cptr, block );
	if(inx >= 0) {
		memcpy( buf, cptr->blocks + inx * cptr->sector_size, cptr->sector_size );
		return(1);
	} else {
		return(0);
	}
}

void cache_remove( cachetype *cptr, int block, int ss )
{
	int inx, from;

	if(!cptr->inited) {
		if(!init(cptr,ss)) return;
		cptr->inited = 1;
	}
	inx = in_cache( cptr, block );
	if(inx >= 0) {
		if(cptr->res_count > 1) {
			from = cptr->res_count-1;
			cptr->block[inx] = cptr->block[from];
			cptr->LRU[inx]   = cptr->LRU[from];
			memcpy(
				cptr->blocks + inx  * cptr->sector_size,
				cptr->blocks + from * cptr->sector_size,
				cptr->sector_size
			);
		}
		cptr->res_count--;
	}
}

//Mac CD-ROM code
//Written by Lauri Pesonen

/*
	CDvMac.c

	10/28/1997
	Copyright (C) 1997 Lauri Pesonen & vMac team.

	Credits go to Peter van Sebille, great ext2 Win95 FSD

	Interface to CDENABLE virtual device driver.

	Implements CD-ROM raw read without thunking down to 16 bit,
	calling API exported by "CDENABLE.VXD".

	// Comments to Weston:

	- CDENABLE.VXD must be within path, preferably Windos or Windos\system
	- Implement your own error handling (sprintf/MessageBox stuff here)
	- CD rom sectors should be read in 2048 byte blocks!
	- You can implement "check for disk availability" function with
		VxdReadCdBytes, just try to read LBA=0, 1 sector (for example)
	- Patch installation (VxdPatchOnOff): It is enough that after a boot,
	  one (any) program calls VxdPatchOnOff(TRUE), BUT: if the same
		program does not remove it, then nobody can do it anymore!
		(Until next boot). I don't think that this really matters.
	- Maximum block size is now 64k. It can be easily enlarged,
	  but if you *now* try to read a larger block you will get a
		blue screen, ring 0 GPF and maybe have to boot.
	- This is for Win95 ONLY! My NT code is in such a state that
	  there is no point in giving it away. CreateFile will
		return error in NT, youmight want to check the OS before.

	- If you face performance problems:
	  You may want to modify the code so that the handle is opened in
		one routine and kept open, now it is opened/closed for every call.
		I suggest that you test it like this first.

		Remember:
			- LBA must be aligned to even sectors, 0,2048,4096, ...
			- count must be even sectors, 2048,4096, ...
			  You should do your own buffering level if you
			  have a slightest doubt that the above does not always hold.
				(Of course it doesn't ...)
*/

#include <stdio.h>
#include <windows.h>


// These DDK files are not needed now.
// #include <vmm.h>
// #include <vxdldr.h>


// This is de facto standard
#define CD_SECTOR_SIZE 2048


// Export these 2 in some h file
//////////////////// C API ////////////////////
// If onoff==TRUE installs the CDVSD patch, if possible.
// If onoff==FALSE removes the CDVSD patch.
// Removing is only possible from the same instance of
// the program, since the linear address is saved into internal
// static variables "sr2" & "patch". You may alter this
// behaviour if you feel like, but be extremely carefull.

// Prototyped at begining of this file
// void VxdPatchOnOff( int onoff );

// Read "count" bytes from "drive" (A=0 etc)
// starting at byte offset "LBA" into "buf"
// Returns 0 on failure, "count" on success

// Prototyped at begining of this file
// int VxdReadCdBytes( int drive, int LBA, int count, char *buf );

//////////////////// C API ////////////////////




//////////////////// VXD API ////////////////////
// Read bytes from block device. Passes the IOP to the
// next DCB downstream.
#define CVXD_APIFUNC_1 1

// Reserved. Do not call.
#define CVXD_APIFUNC_2 2

// Enable patch. Removes the outrageous 0x10 minimum start sector
// check from CDCSD.VXD. Safely enumerates only code segments
// belonging to the target vxd and patches when necessary.
// Touches only page locked segments.
#define CVXD_APIFUNC_3 3

// Restore patch, if possible. The vxd function does
// not validate the passed address, it must be correct.
// Do not try to reference the pointer, it is a ring 0
// linear address.
#define CVXD_APIFUNC_4 4
//////////////////// VXD API ////////////////////


static HANDLE get_handle( void )
{
	HANDLE hCVxD = 0;

  hCVxD = CreateFile( "\\\\.\\CDENABLE.VXD",0,0,0,CREATE_NEW,FILE_FLAG_DELETE_ON_CLOSE,0);
	if(hCVxD != INVALID_HANDLE_VALUE) return(hCVxD);
	return(hCVxD);
}

int ReadCD(int start, int count, char *buf)
{
        int result=0;
        int start0, end0, count0;
        char *tempbuf=0;
        OSVERSIONINFO OSVerInfo;

        OSVerInfo.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
        GetVersionEx(&OSVerInfo);

	// Aligned values:
        start0 = start & 0xFFFFF800;
        end0 = (start+count+CD_SECTOR_SIZE-1) & 0xFFFFF800;
        count0 = end0 - start0;

        tempbuf = (char *)VirtualAlloc( NULL, count0, MEM_RESERVE|MEM_COMMIT, PAGE_READWRITE );
	if(tempbuf) {
	// if(buf) {  // BUGS_BY_LAURI

        GetVersionEx(&OSVerInfo);

        if(OSVerInfo.dwPlatformId==VER_PLATFORM_WIN32_WINDOWS)
          result=VxdReadCdBytes(CDdrive, start0, count0, tempbuf);

        if(OSVerInfo.dwPlatformId==VER_PLATFORM_WIN32_NT)
          result=CdenableSysReadCdBytes(NTCDHandle, start0, count0, tempbuf);

          if(result == count0) {
			memmove(buf,&tempbuf[start-start0],count);
                        result = count;
		} else { // BUGS_BY_LAURI
                        result = 0; // just to be sure.
		}
                VirtualFree( tempbuf, 0, MEM_RELEASE  );
	}

  return(result);
}

int VxdReadCdBytes(int drive, int LBA, int count, char *buf)
{
        HANDLE      hCVxD = 0;
        DWORD       cbBytesReturned;
        DWORD       dwErrorCode;
        DWORD       ReqInfo[4];
        DWORD       ReplyInfo[4];
        int         bytes_read = 0;

	char msg[256];

	// ASSERT MINIMUMS:
	if(count < CD_SECTOR_SIZE) return(0);
	if(LBA < 0) return(0);

	// ASSERT ALIGNMENT:
	if( count & (CD_SECTOR_SIZE-1)) return(0);
	if( LBA & (CD_SECTOR_SIZE-1)) return(0);

  hCVxD = get_handle();

  if ( hCVxD != INVALID_HANDLE_VALUE ) {
  		ReqInfo[0] = drive;
		ReqInfo[1] = LBA;
		ReqInfo[2] = count;
		ReqInfo[3] = (DWORD)buf;
		if ( DeviceIoControl(hCVxD, CVXD_APIFUNC_1,
						(LPVOID)ReqInfo, sizeof(ReqInfo),
						(LPVOID)ReplyInfo, sizeof(ReplyInfo),
						&cbBytesReturned, NULL) )
		{
			bytes_read = ReplyInfo[0];
		} else {
			sprintf(msg,"Device does not support the requested API");
                        //MessageBox( 0, msg, 0, 0 );
                        UseCD=0;
		}
    CloseHandle(hCVxD);
  }
  return(bytes_read);
}

void VxdPatchOnOff( int onoff )
{
  HANDLE      hCVxD = 0;
	int					func = 0;
  DWORD       cbBytesReturned;
  DWORD       ReqInfo[2];
	DWORD       ReplyInfo[2];

	// This is pointer to code, but we are not supposed to know it here
	static DWORD patch = 0;

	// This is true if OSR2 was detected.
	static DWORD sr2 = 0;

  hCVxD = get_handle();
  if ( hCVxD != INVALID_HANDLE_VALUE ) {
		func = onoff ? CVXD_APIFUNC_3 : CVXD_APIFUNC_4;
		if(!onoff) {
			ReqInfo[0] = patch;
			ReqInfo[1] = sr2;
		}
		(void)DeviceIoControl(
						hCVxD,
						func,
						(LPVOID)ReqInfo, sizeof(ReqInfo),
						(LPVOID)ReplyInfo, sizeof(ReplyInfo),
						&cbBytesReturned, NULL);
		if(onoff) {
			patch = ReplyInfo[0];
			sr2 = ReplyInfo[1];
		}
    CloseHandle(hCVxD);
  }
}

int eject_media(char letter, int reload)
{
    MCIERROR err = 0;
	MCIDEVICEID id;
	MCI_OPEN_PARMS op;
	char name[_MAX_PATH];

	sprintf( name, "%c:", letter );

	memset( &op, 0, sizeof(op) );
        op.lpstrDeviceType = (LPCSTR)MCI_DEVTYPE_CD_AUDIO;
        op.lpstrElementName = (LPCSTR)name;

        //Bug: ejects first CD drive
        err = mciSendCommand( NULL, MCI_OPEN, MCI_OPEN_TYPE_ID | MCI_OPEN_TYPE, (DWORD)&op );
        if(err == 0) {
                id = op.wDeviceID;
                // id = MCI_ALL_DEVICE_ID;

                err = mciSendCommand( id, MCI_STOP, 0, 0 );
		// ignore STOP error
		if(reload) {
                        err = mciSendCommand( id, MCI_SET, MCI_SET_DOOR_CLOSED, 0 );
		} else {
                        err = mciSendCommand( id, MCI_SET, MCI_SET_DOOR_OPEN, 0 );
		}
                err = mciSendCommand( id, MCI_CLOSE, MCI_WAIT, 0 );
	}
        return(err==0);
}

//Partition table code for reading hybrid CD's

/*
 * This file is derived from linux/fs/hfs/part_tbl.c
 * by Paul H. Hargrove
 * GNU GPL etc, see file "Copying"
 *
 * Modified to suit my needs. Lauri Pesonen.
 *
 */

// WESTON: these 3 functions should be provided by you:

// Reads "count" bytes from cd handle "hcd" to the "buf"
// Your implementation probably can ignore the "drive" parameter
int cd_read( HANDLE hcd, int drive, int LBA, int count, char *buf );

// Returns a handle to the cd described by "drive"
// You may remove the "check_geometry" parameter.
HANDLE cd_init( int drive, BOOL check_geometry );

// Closes the cd. You may want to change this so
// that a handle is passed it, my implementation
// has a table of 26 drives and the handle is there.
void cd_final( int drive );

int cd_read(HANDLE hcd, int drive, int LBA, int count, char *buf)
{
        return(ReadCD(LBA, count, buf));
}

HANDLE cd_init(int drive, BOOL check_geometry)
{
        return((HANDLE)1);
}

void cd_final(int drive)
{
        return;
}

#define HFS_SECTOR_SIZE		512

/* offsets to various blocks */
#define HFS_DD_BLK		0 /* Driver Descriptor block */
#define HFS_PMAP_BLK		1 /* First block of partition map */
#define HFS_MDB_BLK		2 /* Block (w/i partition) of MDB */

/* magic numbers for various disk blocks */
#define HFS_DRVR_DESC_MAGIC	0x4552 /* "ER": driver descriptor map */
#define HFS_OLD_PMAP_MAGIC	0x5453 /* "TS": old-type partition map */
#define HFS_NEW_PMAP_MAGIC	0x504D /* "PM": new-type partition map */
#define HFS_SUPER_MAGIC		0x4244 /* "BD": HFS MDB (super block) */
#define HFS_MFS_SUPER_MAGIC	0xD2D7 /* MFS MDB (super block) */

typedef short S16;
typedef long S32;
typedef unsigned char U8;
typedef unsigned short U16;
typedef unsigned long U32;

static int parse_old_part_table(char *buf, int part, S32 *size, S32 *start);
static int parse_new_part_table(HANDLE hcd, int drive, char *buf, int part, S32 *size, S32 *start);

// WESTON: Big endian/little endian stuff.
// To be portable should use "htons" family funtions.
// For Wintel machines these are ok

static void macpc_w( char *s )
{
	char s0;
	s0 = s[0];
	s[0] = s[1];
	s[1] = s0;
}

static void macpc_d( char *s )
{
	char s0, s1;
	s0 = s[0];
	s1 = s[1];
	s[0] = s[3];
	s[1] = s[2];
	s[2] = s1;
	s[3] = s0;
}

#define MACPC_W(s) macpc_w((char *)&(s))
#define MACPC_D(s) macpc_d((char *)&(s))

// WESTON: if your compiler does not have "#pragma pack"
// the use something else to ensure that these are packed.

#pragma pack(1)
/*
 * The Macintosh Driver Descriptor Block
 *
 * On partitioned Macintosh media this is block 0.
 * We really only need the "magic number" to check for partitioned media.
 */
typedef struct {
	U16	ddSig;			/* The signature word */
	S16	ddBlkSize;	/* device block size (bytes) */
	/* a bunch more stuff we don't need */
} hfs_drvr_desc;

/*
 * The new style Mac partition map
 *
 * For each partition on the media there is a physical block (512-byte
 * block) containing one of these structures.  These blocks are
 * contiguous starting at block 1.
 */
typedef struct {
	U16	pmSig;				/* Signature bytes to verify that this is a partition map block */
	U16	reSigPad;			/* padding */
	U32	pmMapBlkCnt;	/* (At least in block 1) this is the number of partition map blocks */
	S32	pmPyPartStart;	/* The physical block number
					   of the first block in this partition */
	S32	pmPartBlkCnt;	/* The number of physical blocks in this partition */
	U8	pmPartName[32];	/* (null terminated?) string
					   giving the name of this partition */
	U8	pmPartType[32];	/* (null terminated?) string
					   giving the type of this partition */
	/* a bunch more stuff we don't need */
} new_pmap;

/*
 * The old style Mac partition map
 *
 * The partition map consists for a 2-byte signature followed by an
 * array of these structures.  The map is terminated with an all-zero
 * one of these.
 */
typedef struct {
	S32	pdStart;
	S32	pdSize;
	U32	pdFSID;
} old_pmap_entry;

typedef struct {
	U16	pdSig;	/* Signature bytes */
	old_pmap_entry pdEntry[42];
} old_pmap;
#pragma pack()


// WESTON: everything below, until next WESTON,
// is ok without changes if it compiles without warnings.

/*
 * parse_new_part_table()
 *
 * Parse a new style partition map looking for the
 * start and length of the 'part'th HFS partition.
 */
static int parse_new_part_table(
	HANDLE hcd,
	int drive,
	char *buf,
	int part,
	S32 *size,
	S32 *start
)
{
	new_pmap *pm;
	int pmap_entries;
	int hfs_part = 0;
	int entry;

	pm = (new_pmap *)buf;
	MACPC_D(pm->pmMapBlkCnt);
	pmap_entries = pm->pmMapBlkCnt;

	*start = 0;
	for (entry = 0; (entry < pmap_entries) && !(*start); ++entry) {
		if (entry) {
			/* read the next partition map entry */
			int read_bytes = cd_read( hcd, drive, HFS_SECTOR_SIZE*(HFS_PMAP_BLK + entry), HFS_SECTOR_SIZE, buf );
			if(read_bytes != HFS_SECTOR_SIZE) {
				// hfs_warn("hfs_fs: unable to "
				//         "read partition map.\n");
				goto bail;
			}
			pm = (new_pmap *)buf;
			MACPC_W(pm->pmSig);
			if (pm->pmSig != HFS_NEW_PMAP_MAGIC) {
				// hfs_warn("hfs_fs: invalid "
				//         "entry in partition map\n");
				goto bail;
			}
		}

		/* look for an HFS partition */
		if (!memcmp(pm->pmPartType,"Apple_HFS",9) &&
		    (!part || ((++hfs_part) == part))) {
			/* Found it! */
			MACPC_D(pm->pmPyPartStart);
			MACPC_D(pm->pmPartBlkCnt);
			*start = pm->pmPyPartStart;
			*size = pm->pmPartBlkCnt;
		}
	}

	if (!(*start)) {
		if (part) {
			// hfs_warn("hfs_fs: unable to locate the "
			//         "HFS partition number %d.\n", part);
		} else {
			// hfs_warn("hfs_fs: unable to locate any "
			//	 "HFS partitions.\n");
		}
		goto bail;
	}
	return 0;

bail:
	return 1;
}

/*
 * parse_old_part_table()
 *
 * Parse a old style partition map looking for the
 * start and length of the 'part'th HFS partition.
 */
static int parse_old_part_table(
	char *buf,
	int part,
	S32 *size,
	S32 *start
)
{
	old_pmap *pm = (old_pmap *)buf;
	old_pmap_entry *p = &pm->pdEntry[0];
	int hfs_part = 0;

	while ((p->pdStart || p->pdSize || p->pdFSID) && !(*start)) {
		/* look for an HFS partition */
		MACPC_D(p->pdFSID);
		if ((p->pdFSID == 0x54465331) && /* == "TFS1" */
		    (!part || ((++hfs_part) == part))) {
			/* Found it! */
			MACPC_D(p->pdStart);
			MACPC_D(p->pdSize);
			*start = p->pdStart;
			*size = p->pdSize;
		}
		++p;
	}

	if (!(*start)) {
		if (part) {
			// hfs_warn("hfs_fs: unable to locate the "
			//          "HFS partition number %d.\n", part);
		} else {
			// hfs_warn("hfs_fs: unable to locate any "
			// 	 "HFS partitions.\n");
		}
		return 1;
	}
	return 0;
}

int get_mdb_block_address( HANDLE hcd, int drive, long *start )
{
	char *buf;
	U16 sig, bs;
	int retval = 0;
	int part = 0;
	int read_bytes;
	long size;
	U16 magic;

	size = *start = 0;

	buf = (char *)VirtualAlloc(
				NULL,
				HFS_SECTOR_SIZE,
				MEM_RESERVE | MEM_COMMIT,
				PAGE_READWRITE );
	if(!buf) return(0);

	/* Read block 0 to see if this media is partitioned */
	read_bytes = cd_read( hcd, drive, HFS_SECTOR_SIZE*HFS_DD_BLK, HFS_SECTOR_SIZE, buf );
	if(read_bytes != HFS_SECTOR_SIZE) {
		// hfs_warn("hfs_fs: Unable to read block 0\n");
		goto bail;
	}

  sig = ((hfs_drvr_desc *)buf)->ddSig;
	bs = ((hfs_drvr_desc *)buf)->ddBlkSize;

	MACPC_W(sig);
	MACPC_W(bs);

  if (sig != HFS_DRVR_DESC_MAGIC) {
		/* not on partitioned media */
		read_bytes = cd_read( hcd, drive, HFS_SECTOR_SIZE*HFS_MDB_BLK, HFS_SECTOR_SIZE, buf );
		if(read_bytes != HFS_SECTOR_SIZE) {
			goto bail;
		}
		MACPC_W(sig);
	  if (sig == HFS_MFS_SUPER_MAGIC) {
			retval = 0;
			goto done;
		} else {
			// retval = 1;
			// NEW: now we must not give up that easily. There may be
			// signature/block size header missing (Executor 2 CD).
			// We force it to search partition map, and surrender
			// only it that fails.
			bs = HFS_SECTOR_SIZE;
		}
	}

	if (bs != HFS_SECTOR_SIZE) {
		// hfs_warn("hfs_fs: Block size %d != 512 on dev "
		//	"%s.\n", bs, hfs_mdb_name(sys_mdb));
		goto bail;
	}

	read_bytes = cd_read( hcd, drive, HFS_SECTOR_SIZE*HFS_PMAP_BLK, HFS_SECTOR_SIZE, buf );
	if(read_bytes != HFS_SECTOR_SIZE) {
		// hfs_warn("hfs_fs: unable to read partition map.\n");
		goto bail;
	}

	magic = *((U16 *)buf);
	MACPC_W(magic);
	switch (magic) {
		case HFS_OLD_PMAP_MAGIC:
			retval = parse_old_part_table(buf, part, &size, start);
			break;
		case HFS_NEW_PMAP_MAGIC:
			retval = parse_new_part_table( hcd, drive, buf, part, &size, start);
			break;
		default:
			// hfs_warn("hfs_fs: This disk has an unrecognized "
			//	 "partition map type.\n");
			goto bail;
	}
	if (size < 0) {
		// hfs_warn("hfs_fs: Partition size > 1 Terabyte.\n");
		goto bail;
	} else if (*start < 0) {
		// hfs_warn("hfs_fs: Partition begins beyond 1 Terabyte.\n");
		goto bail;
	}

done:
	VirtualFree( buf, 0, MEM_RELEASE  );
	*start = (*start) * HFS_SECTOR_SIZE;
	return !retval;

bail:
	VirtualFree( buf, 0, MEM_RELEASE  );
	return(0);
}

// WESTON: this simple tester finds first cd and
// when it's done, "start_address" will contain the
// value that should be added to every read by MacOS

// WARNING WARNING WARNING WARNING WARNING WARNING:
//
//		Potential pitfall here:
//
//		When you call this routine, or anything analysing
//		the cd partition tables, the "skewing" should
//		be DISABLED! I mean, you probably implement
//		"cd_read" so that it adds "start_address" calculated
//		here to the seek value passed by MacOS.
//		So, if the "start_address" is a global value,
//		it must be set to zero before reading anything here!
//		I learned this hard way...

void ptable_tester( void )
{
	int drive;
	HANDLE hcd = 0;
	char buffer[256], letter;

        start_address=0;

	drive = -1;
	for( letter = 'C'; letter <= 'Z'; letter++ ) {
		drive = (int)( letter - 'A' );
		wsprintf( buffer, "%c:\\", letter );
		if(GetDriveType( buffer ) == DRIVE_CDROM) {
			break;
		}
	}
	if(drive < 0) {
                vMac_Message("Could not find any cd drives.");
                UseCD=0;
	} else {
		hcd = cd_init( drive, TRUE );
		if(hcd) {
			if(get_mdb_block_address( hcd, drive, &start_address )) {
				wsprintf( buffer, "First HFS partition starts at %08x", start_address );
				vMac_Message(buffer);
			} else {
				vMac_Message("No HFS partitions found.");
			}
			// Note the comment at the start of file, maybe
			// hcd is passed here
			cd_final(drive);
		} else {
			vMac_Message("Could not open cd");
		}
	}
}

//CD-ROM code for Windows NT

/*
		Interface to cdenable.sys driver.
		11/15/1997 Lauri Pesonen
		See the .h file for usage
*/

#include <winioctl.h>
#include <winsvc.h>
//#include "ntcd.h"
//#include "cdenable.h"

static char *sDriverShort   = "cdenable";
static char *sDriverLong  = "System32\\Drivers\\cdenable.sys";
static char *sCompleteName  = "\\\\.\\cdenable";

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Start type must be SERVICE_AUTO_START or lower, in order
// it to start automatically and allow the mechanism work
// for users with no admin rights.
static BOOL InstallDriver(
  IN SC_HANDLE  SchSCManager,
  IN LPCTSTR    DriverName,
  IN LPCTSTR    ServiceExe
)
{
  SC_HANDLE  schService;
  DWORD      err;

  schService = CreateService (
		SchSCManager,          // SCManager database
    DriverName,            // name of service
    DriverName,            // name to display
    SERVICE_ALL_ACCESS,    // desired access
    SERVICE_KERNEL_DRIVER, // service type
		SERVICE_AUTO_START,		 // SERVICE_DEMAND_START,  // start type
    SERVICE_ERROR_NORMAL,  // error control type
    ServiceExe,            // service's binary
    NULL,                  // no load ordering group
    NULL,                  // no tag identifier
    NULL,                  // no dependencies
    NULL,                  // LocalSystem account
    NULL                   // no password
    );

  if (schService == NULL) {
      err = GetLastError();
      if (err == ERROR_SERVICE_EXISTS) {
				  return TRUE;
      } else {
		      return FALSE;
      }
  }
  CloseServiceHandle (schService);
  return TRUE;
}

static BOOL RemoveDriver(
  IN SC_HANDLE  SchSCManager,
  IN LPCTSTR    DriverName
)
{
  SC_HANDLE  schService;
  BOOL       ret;

  schService = OpenService (SchSCManager,
                            DriverName,
                            SERVICE_ALL_ACCESS
                            );
  if (schService == NULL) return FALSE;
  ret = DeleteService (schService);
  CloseServiceHandle (schService);
  return ret;
}

static BOOL StartDriver(
  IN SC_HANDLE  SchSCManager,
  IN LPCTSTR    DriverName
) {
  SC_HANDLE  schService;
  BOOL       ret;
  DWORD      err;

  schService = OpenService (SchSCManager,
                            DriverName,
                            SERVICE_ALL_ACCESS
                            );
  if (schService == NULL) return FALSE;
  ret = StartService (schService,    // service identifier
                      0,             // number of arguments
                      NULL           // pointer to arguments
                      );
  if(ret == 0) {
    err = GetLastError();
    if (err == ERROR_SERVICE_ALREADY_RUNNING) {
			ret = TRUE;
    } else {
			ret = FALSE;
		}
  }
  CloseServiceHandle (schService);
  return ret;
}

static BOOL StopDriver(
  IN SC_HANDLE  SchSCManager,
  IN LPCTSTR    DriverName
)
{
  SC_HANDLE       schService;
  BOOL            ret;
  SERVICE_STATUS  serviceStatus;

  schService = OpenService (SchSCManager,
                            DriverName,
                            SERVICE_ALL_ACCESS
                            );
  if (schService == NULL) return FALSE;
  ret = ControlService (schService,
                        SERVICE_CONTROL_STOP,
                        &serviceStatus
                        );
  CloseServiceHandle (schService);
  return ret;
}

static BOOL __cdecl start_driver( void )
{
	SC_HANDLE   schSCManager;
	BOOL ret = FALSE;

	schSCManager = OpenSCManager( NULL, NULL, SC_MANAGER_ALL_ACCESS );
	if(!schSCManager) return(FALSE);
	if(!InstallDriver( schSCManager, sDriverShort, sDriverLong )) {
		CloseServiceHandle( schSCManager );
		return(FALSE);
	}
	ret = StartDriver( schSCManager, sDriverShort );
	if(!ret) {
		(void)RemoveDriver( schSCManager, sDriverShort );
	}
	CloseServiceHandle( schSCManager );
	return( ret );
}

static BOOL __cdecl stop_driver( void )
{
	SC_HANDLE   schSCManager;
	BOOL ret = FALSE;

	schSCManager = OpenSCManager( NULL, NULL, SC_MANAGER_ALL_ACCESS );
	if(!schSCManager) return(FALSE);
	if(StopDriver( schSCManager, sDriverShort )) ret = TRUE;
	CloseServiceHandle( schSCManager );
	return( ret );
}

static BOOL __cdecl remove_driver( void )
{
	SC_HANDLE   schSCManager;
	BOOL ret = FALSE;

	schSCManager = OpenSCManager( NULL, NULL, SC_MANAGER_ALL_ACCESS );
	if(!schSCManager) return(FALSE);
	if(RemoveDriver( schSCManager, sDriverShort )) ret = TRUE;
	CloseServiceHandle( schSCManager );
	return( ret );
}



// Exported stuff begins

int CdenableSysReadCdBytes( HANDLE h, DWORD start, DWORD count, char *buf )
{
  HANDLE   hDevice;
  int      ret;
	DWORD		 nb;
	DWORD    in_buffer[10];
	DWORD    out_buffer[10];

  ret = 0;

	in_buffer[0] = (DWORD)h;
	in_buffer[1] = (DWORD)start;
	in_buffer[2] = (DWORD)count;
	in_buffer[3] = (DWORD)buf;
	out_buffer[0] = 0;

  hDevice = CreateFile (sCompleteName,
                        GENERIC_READ | GENERIC_WRITE,
                        0,
                        NULL,
                        OPEN_EXISTING,
                        FILE_ATTRIBUTE_NORMAL,
                        NULL
                        );

  if (hDevice == ((HANDLE)-1)) {
    ret = 0;
	} else {
		if ( DeviceIoControl(	hDevice,
					IOCTL_CDENABLE_READ,
					(LPVOID)in_buffer, 16,
					(LPVOID)out_buffer, 4,
					&nb, NULL ) )
		{
			if(out_buffer[0] != 0) ret = count;
		}
    CloseHandle (hDevice);
  }

  return ret;
}

int CdenableSysReadCdSectors( HANDLE h, DWORD start, DWORD count, char *buf )
{
	return( CdenableSysReadCdBytes( h, (start<<11), (count<<11), buf ) );
}

BOOL CdenableSysInstallStart(void)
{
	char dname[64];

        sprintf(dname,"\\\\.\\%c:",(char)('A' + CDdrive));
        NTCDHandle = CreateFile (dname, GENERIC_READ,
                   FILE_SHARE_READ|FILE_SHARE_WRITE,
                   NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL,
                   NULL);
        if( NTCDHandle == INVALID_HANDLE_VALUE )
         {NTCDHandle=0;
          return(0);}

	return(start_driver());
}

void CdenableSysStopRemove(void)
{
        CloseHandle(NTCDHandle);
	stop_driver();
	remove_driver();
}

DWORD CdenableSysGetVersion( void )
{
  HANDLE   hDevice;
  DWORD    ret;
	DWORD		 nb;
	DWORD    out_buffer[10];

  ret = 0;
	out_buffer[0] = 0;
  hDevice = CreateFile (sCompleteName,
                        GENERIC_READ | GENERIC_WRITE,
                        0,
                        NULL,
                        OPEN_EXISTING,
                        FILE_ATTRIBUTE_NORMAL,
                        NULL
                        );
  if (hDevice == ((HANDLE)-1)) {
    ret = 0;
	} else {
		if ( DeviceIoControl(	hDevice,
					IOCTL_CDENABLE_GET_VERSION,
					NULL, 0,
					(LPVOID)out_buffer, 4,
					&nb, NULL ) )
		{
			ret = out_buffer[0];
		}
    CloseHandle (hDevice);
  }
  return ret;
}
